@echo off
REM SET PATH=C:\xblite\bin;%PATH%
SET PATH=%XBLDIR%\bin;%PATH%

REM del *.obj

REM ****************************************************
REM Remember to add any new asm files below!
REM ****************************************************

REM ****************************************************
REM The Main routines, included in every program
REM ****************************************************

	GoAsm xblib0.asm
	if errorlevel 1 goto error

REM ****************************************************
REM Thread safety routines
REM ****************************************************

REM	GoAsm SleepLock.asm
REM	if errorlevel 1 goto error

REM ****************************************************
REM Memory routines
REM ****************************************************

	GoAsm xblibm.asm
	if errorlevel 1 goto error

	GoAsm xblibm1.asm
	if errorlevel 1 goto error

	GoAsm xblibm2.asm
	if errorlevel 1 goto error

REM ****************************************************
REM Clone and concatenate routines
REM ****************************************************

	GoAsm xblibcc.asm
	if errorlevel 1 goto error

	GoAsm xblibcc1.asm
	if errorlevel 1 goto error

REM ****************************************************
REM Low-level array processing
REM ****************************************************

	GoAsm xbliba.asm
	if errorlevel 1 goto error

	GoAsm xbliba1.asm
	if errorlevel 1 goto error

REM ****************************************************
REM Composite String routines
REM ****************************************************

	GoAsm xblibc.asm
	if errorlevel 1 goto error

	GoAsm xblibc1.asm
	if errorlevel 1 goto error

	GoAsm xblibc2.asm
	if errorlevel 1 goto error

	GoAsm xblibc3.asm
	if errorlevel 1 goto error

REM ****************************************************
REM XstStringToNumber ()
REM ****************************************************

	GoAsm xblibn.asm
	if errorlevel 1 goto error

REM ****************************************************
REM PRINT routines
REM ****************************************************

	GoAsm xblibp.asm
	if errorlevel 1 goto error

	GoAsm xblibp1.asm
	if errorlevel 1 goto error

	GoAsm xblibp2.asm
	if errorlevel 1 goto error

	GoAsm xblibp3.asm
	if errorlevel 1 goto error

	GoAsm xblibp4.asm
	if errorlevel 1 goto error

	GoAsm xblibp5.asm
	if errorlevel 1 goto error

	GoAsm xblibp6.asm
	if errorlevel 1 goto error

	GoAsm xblibp7.asm
	if errorlevel 1 goto error

	GoAsm xblibp8.asm
	if errorlevel 1 goto error

	GoAsm xblibp9.asm
	if errorlevel 1 goto error

	GoAsm xblibp10.asm
	if errorlevel 1 goto error

	GoAsm xblibp11.asm
	if errorlevel 1 goto error

REM 	GoAsm xblibp12.asm
REM 	if errorlevel 1 goto error

	GoAsm xblibp13.asm
	if errorlevel 1 goto error

REM ****************************************************
REM String routines
REM ****************************************************

	GoAsm xblibs.asm
	if errorlevel 1 goto error

	GoAsm xblibs1.asm
	if errorlevel 1 goto error

	GoAsm xblibs2.asm
	if errorlevel 1 goto error

REM Done

echo Objects sucessfully built.
goto finished
:error
echo Error building objects.
:finished
pause
