;
; [1] '
;
; [2] ' ####################
;
; [3] ' #####  PROLOG  #####
;
; [4] ' ####################
;
; [5] '
;
; [6] ' This program uses GetTimeFormatA to create a
;
; [7] ' formatted time string. It demonstrates the process
;
; [8] ' of calling API functions. This API function is in the
;
; [9] ' "kernel32" library, which means it needs to be imported
;
; [10] ' by using the IMPORT statement in the PROLOG.
;
; [11] ' See the IMPORT statements below.
;
; [12] '
;
; [13] ' In order to use the function it must be declared
;
; [14] ' in the kernel32.dec declaration file.
;
; [15] '
;
; [16] ' Using goxbl is automatic if compiling using -go command line switch
;
; [17] ' I need here to import the kernel32.dec file for the SYSTEMTIME composite TYPE declaration
;
; [19] PROGRAM "api"
;
; [20] VERSION "0.0002"
;
; [21] CONSOLE
;
; [23] 'IMPORT  "goxbl"
;
; [24] IMPORT	"kernel32.dec"' Import kernel32.dll declarations
.code
	jmp	%_StartApplication			;;; i37a
PrologCode.api:
	push	ebp			;;; i38
	mov	ebp,esp			;;; i39
	sub	esp,256			;;; i40
;
; [25] '
;
; [26] DECLARE  FUNCTION  Entry       ()
;
; [27] '
;
; [28] '
;
; [29] ' ######################
;
; [30] ' #####  Entry ()  #####
;
; [31] ' ######################
;
; [32] '
;
; [33] FUNCTION  Entry ()
.code
	leave	;;; i160a
	ret				;;; i161 ;;; end prolog code
%_StartApplication:
	call	func1.api			;;; i162c
	ret	0			;;; i162d
align 16
Entry.api:
;  *****
;  *****  FUNCTION  Entry ()  *****
;  *****
func1.api:
	enter 8,0			;;; i112
	push	esi			;;; save esi
	push	edi			;;; save edi
	push	ebx			;;; save ebx
  push addr free.func1.api
  push ebp
  push addr XxxUnwinder   ;;; golink proc decoration
  fs push [0]
  fs mov [0],esp  ;;; install unwind handler
	call	%%%%initOnce.api
;
;	#### Begin Local Initialization Code ####
	mov	ecx,2				;;; ..
	xor	eax,eax			;;; ...
A.6:
	push	eax, eax, eax, eax
	push	eax, eax, eax, eax
	dec	ecx					;;; ....
	jnz	< A.6			;;; .....
	push	eax				;;; ......
;	#### End Local Initialization Code ####
;
;	################################################################################
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###
;	### code above, the first 'sub esp,____' line below must be uncommented      ###
;	### and the second must be either deleted or commented out.                  ###
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###
;	################################################################################
;
;	sub esp,220
	sub	esp,152			;;; i114a
;
;	#### Begin Composite Initialization Code ####
	xor	eax,eax		;;; .
	push	eax			;;; ..
	push	eax			;;; ..
	push	eax			;;; ..
	push	eax			;;; ..
	push	eax			;;; ..
;	#### End Composite Initialization Code ####
;
	lea	eax,[esp]			;;; i125
	mov	d[ebp-44],eax			;;; i670
funcBody1.api:
;
; [35] SYSTEMTIME sysTime
; .composites = ebp-40	; internal variable
#ifdef Entry.sysTime
#undef Entry.sysTime
#endif
#define Entry.sysTime ebp-44	; exposes local variable 'sysTime'
;
;
; [37] ' get local time
;
; [38] GetLocalTime (&sysTime)
;
; [0] EXTERNAL FUNCTION GetLocalTime (lpSystemTime)
	mov	eax,d[ebp-44]			;;; i642
	push	eax			;;; i667a
	call	GetLocalTime			;;; i619a -golink decoration
;
; [40] ' set parameters for GetTimeFormatA
;
; [41] timeStr$ = NULL$ (100)
#ifdef Entry.timeStr$
#undef Entry.timeStr$
#endif
#define Entry.timeStr$ ebp-48	; exposes local variable 'timeStr$'
;
	sub	esp,64			;;; i487
	mov	d[esp],100
	call	%_null.d			;;; i573
	add	esp,64			;;; i600
	lea	ebx,[ebp-48]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [42] flags = 0
#ifdef Entry.flags
#undef Entry.flags
#endif
#define Entry.flags ebp-52	; exposes local variable 'flags'
;
	mov	eax,0			;;; i659
	mov	d[ebp-52],eax			;;; i670
;
; [43] format$ = ""
#ifdef Entry.format$
#undef Entry.format$
#endif
#define Entry.format$ ebp-56	; exposes local variable 'format$'
;
	xor	eax,eax			;;; i3
	lea	ebx,[ebp-56]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [44] GetTimeFormatA ($$LOCALE_USER_DEFAULT, flags, &sysTime, &format$, &timeStr$, LEN(timeStr$))
;
; [0] EXTERNAL FUNCTION GetTimeFormatA (Locale, dwFlags, lpTime, lpFormat, lpTimeStr, cchTime)
	mov	eax,d[ebp-44]			;;; i642
; .xstk1.0000 = ebp-64	; internal variable
	mov	d[ebp-64],eax			;;; i670
	mov	eax,d[ebp-56]			;;; i642
; .xstk1.0001 = ebp-72	; internal variable
	mov	d[ebp-72],eax			;;; i670
	mov	eax,d[ebp-48]			;;; i642
; .xstk1.0002 = ebp-80	; internal variable
	mov	d[ebp-80],eax			;;; i670
	mov	eax,d[ebp-48]			;;; i665
	test	eax,eax			;;; i593
	jz	> A.1			;;; i594
	mov	eax,d[eax-8]			;;; i595
A.1:
	push	eax			;;; i667a
	push	[ebp-80]			;;; i674a
	push	[ebp-72]			;;; i674a
	push	[ebp-64]			;;; i674a
	push	[ebp-52]			;;; i674a
	push	1024			;;; i656a
	call	GetTimeFormatA			;;; i619a -golink decoration
;
; [45] timeStr$ = CSIZE$ (timeStr$)
	sub	esp,64			;;; i487
	mov	eax,[ebp-48]			;;; i665
	mov	d[esp],eax			;;; i887
	call	%_csize.d.v			;;; i583
	add	esp,64			;;; i600
	lea	ebx,[ebp-48]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [46] PRINT "Default local time format:", timeStr$
; .filenumber = ebp-84	; internal variable
	push	1			;;; i844
	sub	esp,64			;;; i845
	mov	eax,addr @_string.0033.api			;;; i663
	call	%_clone.a0			;;; i429
	call	%_PrintAppendComma			;;; i854
	mov	ebx,[ebp-48]			;;; i665
	call	%_clone.a1			;;; i429
	push eax
	push ebx
	push 6
	call main.concat	;;; i291a
	add esp,12
	add	esp,64
	call	%_PrintWithNewlineThenFree			;;; i859
	add	esp,4
;
; [48] ' use a time format string
;
; [49] timeStr$ = NULL$ (100)
	sub	esp,64			;;; i487
	mov	d[esp],100
	call	%_null.d			;;; i573
	add	esp,64			;;; i600
	lea	ebx,[ebp-48]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [50] flags = 0
	mov	eax,0			;;; i659
	mov	d[ebp-52],eax			;;; i670
;
; [51] format$ = "hh\':\'mm\':\'ss tt"' use escape backslash before :
	mov	eax,addr @_string.0034.api			;;; i663
	call	%_clone.a0			;;; i3a
	lea	ebx,[ebp-56]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [52] GetTimeFormatA ($$LOCALE_USER_DEFAULT, flags, &sysTime, &format$, &timeStr$, LEN(timeStr$))
	mov	eax,d[ebp-44]			;;; i642
	mov	d[ebp-64],eax			;;; i670
	mov	eax,d[ebp-56]			;;; i642
	mov	d[ebp-72],eax			;;; i670
	mov	eax,d[ebp-48]			;;; i642
	mov	d[ebp-80],eax			;;; i670
	mov	eax,d[ebp-48]			;;; i665
	test	eax,eax			;;; i593
	jz	> A.2			;;; i594
	mov	eax,d[eax-8]			;;; i595
A.2:
	push	eax			;;; i667a
	push	[ebp-80]			;;; i674a
	push	[ebp-72]			;;; i674a
	push	[ebp-64]			;;; i674a
	push	[ebp-52]			;;; i674a
	push	1024			;;; i656a
	call	GetTimeFormatA			;;; i619a -golink decoration
;
; [53] timeStr$ = CSIZE$ (timeStr$)
	sub	esp,64			;;; i487
	mov	eax,[ebp-48]			;;; i665
	mov	d[esp],eax			;;; i887
	call	%_csize.d.v			;;; i583
	add	esp,64			;;; i600
	lea	ebx,[ebp-48]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [54] PRINT "Use time format string   :", timeStr$
	push	1			;;; i844
	sub	esp,64			;;; i845
	mov	eax,addr @_string.0035.api			;;; i663
	call	%_clone.a0			;;; i429
	call	%_PrintAppendComma			;;; i854
	mov	ebx,[ebp-48]			;;; i665
	call	%_clone.a1			;;; i429
	push eax
	push ebx
	push 6
	call main.concat	;;; i291a
	add esp,12
	add	esp,64
	call	%_PrintWithNewlineThenFree			;;; i859
	add	esp,4
;
; [56] ' use a time format string
;
; [57] timeStr$ = NULL$ (100)
	sub	esp,64			;;; i487
	mov	d[esp],100
	call	%_null.d			;;; i573
	add	esp,64			;;; i600
	lea	ebx,[ebp-48]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [58] flags = 0
	mov	eax,0			;;; i659
	mov	d[ebp-52],eax			;;; i670
;
; [59] format$ = "HH\'h\'mm"
	mov	eax,addr @_string.0036.api			;;; i663
	call	%_clone.a0			;;; i3a
	lea	ebx,[ebp-56]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [60] GetTimeFormatA ($$LOCALE_USER_DEFAULT, flags, &sysTime, &format$, &timeStr$, LEN(timeStr$))
	mov	eax,d[ebp-44]			;;; i642
	mov	d[ebp-64],eax			;;; i670
	mov	eax,d[ebp-56]			;;; i642
	mov	d[ebp-72],eax			;;; i670
	mov	eax,d[ebp-48]			;;; i642
	mov	d[ebp-80],eax			;;; i670
	mov	eax,d[ebp-48]			;;; i665
	test	eax,eax			;;; i593
	jz	> A.3			;;; i594
	mov	eax,d[eax-8]			;;; i595
A.3:
	push	eax			;;; i667a
	push	[ebp-80]			;;; i674a
	push	[ebp-72]			;;; i674a
	push	[ebp-64]			;;; i674a
	push	[ebp-52]			;;; i674a
	push	1024			;;; i656a
	call	GetTimeFormatA			;;; i619a -golink decoration
;
; [61] timeStr$ = CSIZE$ (timeStr$)
	sub	esp,64			;;; i487
	mov	eax,[ebp-48]			;;; i665
	mov	d[esp],eax			;;; i887
	call	%_csize.d.v			;;; i583
	add	esp,64			;;; i600
	lea	ebx,[ebp-48]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [62] PRINT "Use time format string   :", timeStr$
	push	1			;;; i844
	sub	esp,64			;;; i845
	mov	eax,addr @_string.0035.api			;;; i663
	call	%_clone.a0			;;; i429
	call	%_PrintAppendComma			;;; i854
	mov	ebx,[ebp-48]			;;; i665
	call	%_clone.a1			;;; i429
	push eax
	push ebx
	push 6
	call main.concat	;;; i291a
	add esp,12
	add	esp,64
	call	%_PrintWithNewlineThenFree			;;; i859
	add	esp,4
;
; [64] a$ = INLINE$ ("Press Enter to quit >")
#ifdef Entry.a$
#undef Entry.a$
#endif
#define Entry.a$ ebp-88	; exposes local variable 'a$'
;
	sub	esp,64			;;; i487
	mov	eax,addr @_string.0038.api			;;; i663
	mov	d[esp],eax			;;; i887
	call	%_inline_d.v
	add	esp,64			;;; i600
	lea	ebx,[ebp-88]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [66] END FUNCTION
	xor	eax,eax			;;; i862
align 8
end.Entry.api:  ;;; Function end label for Assembly Programmers.
end.func1.api:
  mov ebx,[ebp-36]
  fs mov [0],ebx       ;;; remove unwind handler
  call free.func1.api
	call	end_program.api			;;; i108
	lea	esp,[ebp-20]				;;; i110
	pop	ebx				;;; restore ebx
	pop	edi				;;; restore edi
	pop	esi				;;; restore esi
	leave					;;;  i111 replaces 'mov esp,ebp' 'pop ebp'
	ret						;;; i111d
free.func1.api:
	mov	esi,[ebp-56]			;;; i665
	call	%____free			;;; i423
	mov	esi,[ebp-48]			;;; i665
	call	%____free			;;; i423
	mov	esi,[ebp-88]			;;; i665
	call	%____free			;;; i423
  ret
;-peep
;  *****
;  *****  END FUNCTION  Entry ()  *****
;  *****
%%%%initOnce.api:
	cmp d[%%%entered.api],-1		;;; i117
	jne > A.8	;;; i117a
	ret			;;; i117b
A.8:
	call	PrologCode.api			;;; i118a
	mov esi,addr %_begin_external_data_api
	mov edi,addr %_end_external_data_api
	call %_ZeroMemory
	call	InitSharedComposites.api			;;; i119
	mov	d[%%%entered.api],-1
	ret				;;; i120
data section 'api$internals'
align 4
%%%entered.api:
db 4 dup ?
.code
;
; [67] END PROGRAM
;<peep
end_program.api:
	enter 128,0		;;; i128
	call	XxxTerminate		   ;;; i131a -golink decoration
	leave			;;; i132
	ret				;;; i134
;
InitSharedComposites.api:
	ret				;;; i143
;
.code
; ########################
; #####  WinMain ()  #####
; ########################
align 8
WinMain:                     ; golink label
_main:												; C entry label
_WinMain:										; Windows entry label
_WinMain@16:									; Windows entry label
	enter 0,0
	push addr %_StartApplication
	call Xit                  ; golink decoration for proc
	call XxxTerminate         ; golink decoration for proc
	leave
	ret
;
;;;  *****  DEFINE '.bss' SECTION LIMITS  *****
;
align 8
data section 'api$aaaaa'
%_begin_external_data_api dd ?
;
align 8
data section 'api$zzzzz'
%_end_external_data_api dd ?
;
;
;;;  *****  DEFINE LITERAL STRINGS  *****
.const
align 8
;
dd 24, 0, 3, 0x80130001
@_string.0029.api:
db	"api"
db	5 dup 0
;
dd 24, 0, 6, 0x80130001
@_string.002A.api:
db	"0.0002"
db	2 dup 0
;
dd 32, 0, 12, 0x80130001
@_string.002B.api:
db	"kernel32.dec"
db	4 dup 0
;
dd 48, 0, 26, 0x80130001
@_string.0033.api:
db	"Default local time format:"
db	6 dup 0
;
dd 32, 0, 15, 0x80130001
@_string.0034.api:
db	"hh':'mm':'ss tt"
db	1 dup 0
;
dd 48, 0, 26, 0x80130001
@_string.0035.api:
db	"Use time format string   :"
db	6 dup 0
;
dd 24, 0, 7, 0x80130001
@_string.0036.api:
db	"HH'h'mm"
db	1 dup 0
;
dd 40, 0, 21, 0x80130001
@_string.0038.api:
db	"Press Enter to quit >"
db	3 dup 0
;
dd 32, 0, 15, 0x80130001
@_string.StartLibrary.api:
db	"%_StartLibrary_"
db	1 dup 0
