;
; [2] ' example using go tools and goxbl.dll
;
; [3] ' example of calling an external dll, xma.dll, or static library xma_s.lib
;
; [4] ' also not required to use IMPORT "goxbl.dll" as that is the default when using -go command line switch
;
; [5] ' build in commmand console using:
;
; [6] ' xblite log.x -go
;
; [7] ' goasm log.asm
;
; [8] ' golink /console /entry:WinMain log.obj goxbl.dll
;
; [9] ' or run: log.bat
;
; [10] '
;
; [11] ' only need to define function when calling a static library
;
; [12] ' when calling a static library function, must first define source of function
;
; [13] ' which in this case is xma_s.lib
#define Log xma_s.lib:Log
#define Exp xma_s.lib:Exp
;
; [18] CONSOLE
;
; [19] 'IMPORT "xst_s.lib"
;
; [20] 'IMPORT "goxbl.dll"
;
; [21] IMPORT "xma_s.lib"
.code
	jmp	%_StartApplication			;;; i37a
PrologCode.log:
	push	ebp			;;; i38
	mov	ebp,esp			;;; i39
	sub	esp,256			;;; i40
;
; [22] 'IMPORT "xma.dec"
;
; [23] 'IMPORT "xma.dll"
;
; [25] DECLARE FUNCTION Entry ()
;
; [27] FUNCTION Entry ()
.code
	leave	;;; i160a
	ret				;;; i161 ;;; end prolog code
%_StartApplication:
	call	func1.log			;;; i162c
	ret	0			;;; i162d
align 16
Entry.log:
;  *****
;  *****  FUNCTION  Entry ()  *****
;  *****
func1.log:
	enter 8,0			;;; i112
	push	esi			;;; save esi
	push	edi			;;; save edi
	push	ebx			;;; save ebx
  push addr free.func1.log
  push ebp
  push addr XxxUnwinder   ;;; golink proc decoration
  fs push [0]
  fs mov [0],esp  ;;; install unwind handler
	call	%%%%initOnce.log
;
;	#### Begin Local Initialization Code ####
	mov	ecx,3				;;; ..
	xor	eax,eax			;;; ...
A.3:
	push	eax, eax, eax, eax
	dec	ecx					;;; ....
	jnz	< A.3			;;; .....
;	#### End Local Initialization Code ####
;
;	################################################################################
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###
;	### code above, the first 'sub esp,____' line below must be uncommented      ###
;	### and the second must be either deleted or commented out.                  ###
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###
;	################################################################################
;
;	sub esp,220
	sub	esp,172			;;; i114a
;
funcBody1.log:
;
; [29] DOUBLE x, y
#ifdef Entry.x
#undef Entry.x
#endif
#define Entry.x ebp-44	; exposes local variable 'x'
;
#ifdef Entry.y
#undef Entry.y
#endif
#define Entry.y ebp-52	; exposes local variable 'y'
;
;
; [31] y = 100.0
	push	1120403456			;;; i654
	fld	d[esp]			;;; i655
	add	esp,4			;;; i656
	fstp	q[ebp-52]			;;; i669
;
; [32] x = Log (y)
;
; [0] EXTERNAL  FUNCTION  DOUBLE  Log     (DOUBLE x)
	fld	q[ebp-52]			;;; i674
	sub	esp,8			;;; i675a
	fstp	q[esp]			;;; i675b
	call	Log			;;; i619a -golink decoration
	fstp	q[ebp-44]			;;; i669
;
; [33] ? "Log(100) = "; x
; .filenumber = ebp-56	; internal variable
	push	1			;;; i844
	sub	esp,64			;;; i845
	mov	eax,addr @_string.002D.log			;;; i663
	call	%_clone.a0			;;; i429
	fld	q[ebp-44]			;;; i664
	push	eax
	sub	esp,64
	fstp	q[esp]
	call	%_str.d.double			;;; i849a
	add	esp,64			;;; i849b
	mov	ebx,eax			;;; i849c
	pop	eax			;;; i849d
	push eax
	push ebx
	push 6
	call main.concat	;;; i291a
	add esp,12
	add	esp,64
	call	%_PrintWithNewlineThenFree			;;; i859
	add	esp,4
;
; [34] y = Exp(x)
;
; [0] EXTERNAL FUNCTION  DOUBLE  Exp     (DOUBLE x)
	fld	q[ebp-44]			;;; i674
	sub	esp,8			;;; i675a
	fstp	q[esp]			;;; i675b
	call	Exp			;;; i619a -golink decoration
	fstp	q[ebp-52]			;;; i669
;
; [35] ? "Exp("; STRING$(x); ") = "; y
	push	1			;;; i844
	sub	esp,64			;;; i845
	mov	eax,addr @_string.002E.log			;;; i663
	call	%_clone.a0			;;; i429
; .xstk1.0000 = ebp-64	; internal variable
	mov	[ebp-64],eax			;;; i670
	sub	esp,64			;;; i487
	mov	eax,d[ebp-44]			;;; i665
	mov	edx,d[ebp-40]
	mov	d[esp],eax			;;; i885
	mov	d[esp+4],edx			;;; i886
	call	%_string.double			;;; i576
	add	esp,64			;;; i600
	mov	ebx,[ebp-64]			;;; i665
	push ebx
	push eax
	push 6
	call main.concat	;;; i291
	add esp,12
	mov	ebx,addr @_string.002F.log			;;; i663
	call	%_clone.a1			;;; i429
	push eax
	push ebx
	push 6
	call main.concat	;;; i291a
	add esp,12
	fld	q[ebp-52]			;;; i664
	push	eax
	sub	esp,64
	fstp	q[esp]
	call	%_str.d.double			;;; i849a
	add	esp,64			;;; i849b
	mov	ebx,eax			;;; i849c
	pop	eax			;;; i849d
	push eax
	push ebx
	push 6
	call main.concat	;;; i291a
	add esp,12
	add	esp,64
	call	%_PrintWithNewlineThenFree			;;; i859
	add	esp,4
;
; [38] a$ = INLINE$ ("Press Enter to quit >")
#ifdef Entry.a$
#undef Entry.a$
#endif
#define Entry.a$ ebp-68	; exposes local variable 'a$'
;
	sub	esp,64			;;; i487
	mov	eax,addr @_string.0031.log			;;; i663
	mov	d[esp],eax			;;; i887
	call	%_inline_d.v
	add	esp,64			;;; i600
	lea	ebx,[ebp-68]			;;; i5
	mov	esi,d[ebx]			;;; i6a
	mov	d[ebx],eax			;;; i6b
	call	%____free			;;; i6c
;
; [40] END FUNCTION
	xor	eax,eax			;;; i862
align 8
end.Entry.log:  ;;; Function end label for Assembly Programmers.
end.func1.log:
  mov ebx,[ebp-36]
  fs mov [0],ebx       ;;; remove unwind handler
  call free.func1.log
	call	end_program.log			;;; i108
	lea	esp,[ebp-20]				;;; i110
	pop	ebx				;;; restore ebx
	pop	edi				;;; restore edi
	pop	esi				;;; restore esi
	leave					;;;  i111 replaces 'mov esp,ebp' 'pop ebp'
	ret						;;; i111d
free.func1.log:
	mov	esi,[ebp-68]			;;; i665
	call	%____free			;;; i423
  ret
;-peep
;  *****
;  *****  END FUNCTION  Entry ()  *****
;  *****
%%%%initOnce.log:
	cmp d[%%%entered.log],-1		;;; i117
	jne > A.4	;;; i117a
	ret			;;; i117b
A.4:
	call	PrologCode.log			;;; i118a
	mov esi,addr %_begin_external_data_log
	mov edi,addr %_end_external_data_log
	call %_ZeroMemory
	call	InitSharedComposites.log			;;; i119
	mov	d[%%%entered.log],-1
	ret				;;; i120
data section 'log$internals'
align 4
%%%entered.log:
db 4 dup ?
.code
;
; [41] END PROGRAM
;<peep
end_program.log:
	enter 128,0		;;; i128
	call	XxxTerminate		   ;;; i131a -golink decoration
	leave			;;; i132
	ret				;;; i134
;
InitSharedComposites.log:
	ret				;;; i143
;
.code
; ########################
; #####  WinMain ()  #####
; ########################
align 8
WinMain:                     ; golink label
_main:												; C entry label
_WinMain:										; Windows entry label
_WinMain@16:									; Windows entry label
	enter 0,0
	push addr %_StartApplication
	call Xit                  ; golink decoration for proc
	call XxxTerminate         ; golink decoration for proc
	leave
	ret
;
;;;  *****  DEFINE '.bss' SECTION LIMITS  *****
;
align 8
data section 'log$aaaaa'
%_begin_external_data_log dd ?
;
align 8
data section 'log$zzzzz'
%_end_external_data_log dd ?
;
;
;;;  *****  DEFINE LITERAL STRINGS  *****
.const
align 8
;
dd 32, 0, 9, 0x80130001
@_string.0029.log:
db	"xma_s.lib"
db	7 dup 0
;
dd 32, 0, 11, 0x80130001
@_string.002D.log:
db	"Log(100) = "
db	5 dup 0
;
dd 24, 0, 4, 0x80130001
@_string.002E.log:
db	"Exp("
db	4 dup 0
;
dd 24, 0, 4, 0x80130001
@_string.002F.log:
db	") = "
db	4 dup 0
;
dd 40, 0, 21, 0x80130001
@_string.0031.log:
db	"Press Enter to quit >"
db	3 dup 0
;
dd 32, 0, 15, 0x80130001
@_string.StartLibrary.log:
db	"%_StartLibrary_"
db	1 dup 0
