; [3351] FUNCTION  XstExceptionToSystemException (exception, sysException)  
.code 
; 
#ifdef XstExceptionToSystemException.exception  
#undef XstExceptionToSystemException.exception  
#endif  
#define XstExceptionToSystemException.exception ebp+8	; exposes function argument 'exception' 
; 
; 
#ifdef XstExceptionToSystemException.sysException 
#undef XstExceptionToSystemException.sysException 
#endif  
#define XstExceptionToSystemException.sysException ebp+12	; exposes function argument 'sysException'  
; 
align 16  
_XstExceptionToSystemException@8: 
;  *****  
;  *****  FUNCTION  XstExceptionToSystemException ()  ***** 
;  *****  
func36.xst: 
push	ebp			;;; i112 
mov	ebp,esp		;;; i113 
sub	esp,8			;;; i114  
push	esi			;;; save esi 
push	edi			;;; save edi 
push	ebx			;;; save ebx 
sub esp,16      ;;; reserved for unwind handler 
; 
;	#### Begin Local Initialization Code #### 
xor	eax,eax		;;; .  
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
;	#### End Local Initialization Code #### 
; 
;	################################################################################  
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###  
;	### code above, the first 'sub esp,____' line below must be uncommented      ###  
;	### and the second must be either deleted or commented out.                  ###  
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###  
;	################################################################################  
; 
;	sub esp,220 
sub	esp,200			;;; i114a 
; 
funcBody36.xst: 
; 
; [3352] SHARED exception$[]  
; 
; [3353] IFZ exception$[] THEN InitExceptionArray() 
mov	eax,d[%%%exception$.xst]			;;; i663a  
test	eax,eax			;;; i194 
jnz	>> else.0127.xst			;;; i195 
call	func41.xst			;;; i619b 
else.0127.xst:  
end.if.0127.xst:  
; 
; [3355] SELECT CASE exception  
mov	eax,d[ebp+8]			;;; i665 
; .select36.0128 = ebp-40	; internal variable 
mov	d[ebp-40],eax			;;; i670  
; 
; [3356] CASE $$ExceptionSegmentViolation					: sysException = $$EXCEPTION_ACCESS_VIOLATION 
mov	eax,1			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0001.xst			;;; i71 
mov	eax,-1073741819			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3357] CASE $$ExceptionOutOfBounds								: sysException = $$EXCEPTION_ARRAY_BOUNDS_EXCEEDED  
jmp	end.select.0128.xst			;;; i69 
case.0128.0001.xst: 
mov	eax,2			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0002.xst			;;; i71 
mov	eax,-1073741684			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3358] CASE $$ExceptionBreakpoint								: sysException = $$EXCEPTION_BREAKPOINT  
jmp	end.select.0128.xst			;;; i69 
case.0128.0002.xst: 
mov	eax,3			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0003.xst			;;; i71 
mov	eax,-2147483645			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3359] CASE $$ExceptionBreakKey									: sysException = $$EXCEPTION_CONTROL_C_EXIT 
jmp	end.select.0128.xst			;;; i69 
case.0128.0003.xst: 
mov	eax,4			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0004.xst			;;; i71 
mov	eax,-1073741510			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3360] CASE $$ExceptionAlignment									: sysException = $$EXCEPTION_DATATYPE_MISALIGNMENT 
jmp	end.select.0128.xst			;;; i69 
case.0128.0004.xst: 
mov	eax,5			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0005.xst			;;; i71 
mov	eax,-2147483646			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3361] CASE $$ExceptionDenormal									: sysException = $$EXCEPTION_FLOAT_DENORMAL_OPERAND 
jmp	end.select.0128.xst			;;; i69 
case.0128.0005.xst: 
mov	eax,6			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0006.xst			;;; i71 
mov	eax,-1073741683			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3362] CASE $$ExceptionDivideByZero							: sysException = $$EXCEPTION_FLOAT_DIVIDE_BY_ZERO 
jmp	end.select.0128.xst			;;; i69 
case.0128.0006.xst: 
mov	eax,7			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0007.xst			;;; i71 
mov	eax,-1073741682			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3363] CASE $$ExceptionInvalidOperation					: sysException = $$EXCEPTION_FLOAT_INVALID_OPERATION  
jmp	end.select.0128.xst			;;; i69 
case.0128.0007.xst: 
mov	eax,8			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0008.xst			;;; i71 
mov	eax,-1073741680			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3364] CASE $$ExceptionOverflow									: sysException = $$EXCEPTION_FLOAT_OVERFLOW 
jmp	end.select.0128.xst			;;; i69 
case.0128.0008.xst: 
mov	eax,9			;;; i659  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0009.xst			;;; i71 
mov	eax,-1073741679			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3365] CASE $$ExceptionStackCheck								: sysException = $$EXCEPTION_FLOAT_STACK_CHECK 
jmp	end.select.0128.xst			;;; i69 
case.0128.0009.xst: 
mov	eax,10			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.000A.xst			;;; i71 
mov	eax,-1073741678			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3366] CASE $$ExceptionUnderflow									: sysException = $$EXCEPTION_FLOAT_UNDERFLOW 
jmp	end.select.0128.xst			;;; i69 
case.0128.000A.xst: 
mov	eax,11			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.000B.xst			;;; i71 
mov	eax,-1073741677			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3367] CASE $$ExceptionInvalidInstruction				: sysException = $$EXCEPTION_ILLEGAL_INSTRUCTION 
jmp	end.select.0128.xst			;;; i69 
case.0128.000B.xst: 
mov	eax,12			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.000C.xst			;;; i71 
mov	eax,-1073741795			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3368] CASE $$ExceptionPrivilege									: sysException = $$EXCEPTION_PRIV_INSTRUCTION  
jmp	end.select.0128.xst			;;; i69 
case.0128.000C.xst: 
mov	eax,13			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.000D.xst			;;; i71 
mov	eax,-1073741674			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3369] CASE $$ExceptionStackOverflow							: sysException = $$EXCEPTION_STACK_OVERFLOW  
jmp	end.select.0128.xst			;;; i69 
case.0128.000D.xst: 
mov	eax,14			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.000E.xst			;;; i71 
mov	eax,-1073741571			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3370] CASE $$ExceptionIntDivideByZero						: sysException = $$EXCEPTION_INT_DIVIDE_BY_ZERO 
jmp	end.select.0128.xst			;;; i69 
case.0128.000E.xst: 
mov	eax,18			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.000F.xst			;;; i71 
mov	eax,-1073741676			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3371] CASE $$ExceptionIntOverflow								: sysException = $$EXCEPTION_INT_OVERFLOW 
jmp	end.select.0128.xst			;;; i69 
case.0128.000F.xst: 
mov	eax,19			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0010.xst			;;; i71 
mov	eax,-1073741675			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3372] CASE $$ExceptionPrecision                 : sysException = $$EXCEPTION_FLOAT_INEXACT_RESULT  
jmp	end.select.0128.xst			;;; i69 
case.0128.0010.xst: 
mov	eax,20			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0011.xst			;;; i71 
mov	eax,-1073741681			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3373] CASE $$ExceptionGuardPage                 : sysException = $$EXCEPTION_GUARD_PAGE  
jmp	end.select.0128.xst			;;; i69 
case.0128.0011.xst: 
mov	eax,21			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0012.xst			;;; i71 
mov	eax,-2147483647			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3374] CASE $$ExceptionInPage                    : sysException = $$EXCEPTION_IN_PAGE_ERROR 
jmp	end.select.0128.xst			;;; i69 
case.0128.0012.xst: 
mov	eax,22			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0013.xst			;;; i71 
mov	eax,-1073741818			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3375] CASE $$ExceptionDisposition               : sysException = $$EXCEPTION_INVALID_DISPOSITION 
jmp	end.select.0128.xst			;;; i69 
case.0128.0013.xst: 
mov	eax,23			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0014.xst			;;; i71 
mov	eax,-1073741786			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3376] CASE $$ExceptionNoncontinuable            : sysException = $$EXCEPTION_NONCONTINUABLE_EXCEPTION  
jmp	end.select.0128.xst			;;; i69 
case.0128.0014.xst: 
mov	eax,24			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0015.xst			;;; i71 
mov	eax,-1073741787			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3377] CASE $$ExceptionSingleStep                : sysException = $$EXCEPTION_SINGLE_STEP 
jmp	end.select.0128.xst			;;; i69 
case.0128.0015.xst: 
mov	eax,25			;;; i659 
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.0128.0016.xst			;;; i71 
mov	eax,-2147483644			;;; i657  
mov	d[ebp+12],eax			;;; i670  
; 
; [3378] CASE ELSE  
jmp	end.select.0128.xst			;;; i69 
case.0128.0016.xst: 
; 
; [3379] sysException = 0 
mov	eax,0			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3380] IF exception < 0 THEN RETURN $$TRUE  
mov	eax,d[ebp+8]			;;; i665 
cmp	eax,0			;;; i684a 
jge	>> else.0129.xst			;;; i219 
mov	eax,-1			;;; i659 
jmp	end.func36.xst			;;; i258 
else.0129.xst:  
end.if.0129.xst:  
; 
; [3381] IF exception > #exceptionMax THEN RETURN $$TRUE  
mov	eax,d[ebp+8]			;;; i665 
mov	ebx,d[%#exceptionMax.xst]			;;; i663a 
cmp	eax,ebx			;;; i684a 
jle	>> else.012A.xst			;;; i219 
mov	eax,-1			;;; i659 
jmp	end.func36.xst			;;; i258 
else.012A.xst:  
end.if.012A.xst:  
; 
; [3382] IFZ exception$[exception] THEN RETURN $$TRUE 
mov	eax,d[ebp+8]			;;; i665 
mov	edx,d[%%%exception$.xst]			;;; i663a  
mov	eax,[edx+eax*4]			;;; i464  
test	eax,eax			;;; i188 
jz	> A.278			;;; i189 
mov	eax,d[eax-8]			;;; i190 
test	eax,eax			;;; i191 
jnz	>> else.012B.xst			;;; i192 
A.278:  
mov	eax,-1			;;; i659 
jmp	end.func36.xst			;;; i258 
else.012B.xst:  
end.if.012B.xst:  
; 
; [3383] sysException = $$ExceptionTypeError | $$ExceptionCodeUser | exception  
mov	eax,-1073741824			;;; i657  
or	eax,536870912			;;; i763 
mov	ebx,d[ebp+8]			;;; i665 
or	eax,ebx			;;; i763 
mov	d[ebp+12],eax			;;; i670  
; 
; [3384] END SELECT 
end.select.0128.xst:  
; 
; [3385] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XstExceptionToSystemException.xst:  ;;; Function end label for Assembly Programmers.  
end.func36.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	8			;;; i111a 
