; [2252] FUNCTION  USHORT XstSetFPURounding (mode)  
.code 
; 
#ifdef XstSetFPURounding.mode 
#undef XstSetFPURounding.mode 
#endif  
#define XstSetFPURounding.mode ebp+8	; exposes function argument 'mode' 
; 
align 16  
_XstSetFPURounding@4: 
;  *****  
;  *****  FUNCTION  XstSetFPURounding ()  ***** 
;  *****  
func20.xst: 
push	ebp			;;; i112 
mov	ebp,esp		;;; i113 
sub	esp,8			;;; i114  
push	esi			;;; save esi 
push	edi			;;; save edi 
push	ebx			;;; save ebx 
sub esp,16      ;;; reserved for unwind handler 
; 
;	#### Begin Local Initialization Code #### 
xor	eax,eax		;;; .  
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
;	#### End Local Initialization Code #### 
; 
;	################################################################################  
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###  
;	### code above, the first 'sub esp,____' line below must be uncommented      ###  
;	### and the second must be either deleted or commented out.                  ###  
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###  
;	################################################################################  
; 
;	sub esp,220 
sub	esp,192			;;; i114a 
; 
funcBody20.xst: 
; 
; [2254] ' The RC field in the control word (bits 11 and 10)  
; 
; [2255] ' or Rounding Control determines how the FPU will  
; 
; [2256] ' round results in one of four ways: 
; 
; [2258] ' 00 = Round to nearest, or to even if equidistant (this is the initialized state) 
; 
; [2259] ' 01 = Round down (toward -infinity) 
; 
; [2260] ' 10 = Round up (toward +infinity) 
; 
; [2261] ' 11 = Truncate (toward 0) 
; 
; [2263] ' rounding modes 
; 
; [2264] ' $$ROUND_NEAREST = 0  
; 
; [2265] ' $$ROUND_DOWN = 1 
; 
; [2266] ' $$ROUND_UP = 2 
; 
; [2267] ' $$TRUNCATE = 3 
; 
; [2269] USHORT cw, cwLast  
#ifdef XstSetFPURounding.cw 
#undef XstSetFPURounding.cw 
#endif  
#define XstSetFPURounding.cw ebp-40	; exposes local variable 'cw' 
; 
#ifdef XstSetFPURounding.cwLast 
#undef XstSetFPURounding.cwLast 
#endif  
#define XstSetFPURounding.cwLast ebp-44	; exposes local variable 'cwLast' 
; 
; 
; [2271] cw = XstGetFPUControlWord () 
call	func1D.xst			;;; i619b 
mov	d[ebp-40],eax			;;; i670  
; 
; [2272] cwLast = cw  
mov	eax,d[ebp-40]			;;; i665  
mov	d[ebp-44],eax			;;; i670  
; 
; [2273] cw = cw & 0xF3FF' clear bits 10 - 11 
mov	eax,d[ebp-40]			;;; i665  
and	eax,62463			;;; i769  
mov	d[ebp-40],eax			;;; i670  
; 
; [2274] SELECT CASE mode 
mov	eax,d[ebp+8]			;;; i665 
; .select20.00F8 = ebp-48	; internal variable 
mov	d[ebp-48],eax			;;; i670  
; 
; [2275] CASE $$ROUND_NEAREST 	:  
mov	eax,0			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F8.0001.xst			;;; i71 
; 
; [2276] CASE $$ROUND_DOWN 		: cw = cw | 0x0400 
jmp	end.select.00F8.xst			;;; i69 
case.00F8.0001.xst: 
mov	eax,1			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F8.0002.xst			;;; i71 
mov	eax,d[ebp-40]			;;; i665  
or	eax,1024			;;; i763  
mov	d[ebp-40],eax			;;; i670  
; 
; [2277] CASE $$ROUND_UP				: cw = cw | 0x0800  
jmp	end.select.00F8.xst			;;; i69 
case.00F8.0002.xst: 
mov	eax,2			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F8.0003.xst			;;; i71 
mov	eax,d[ebp-40]			;;; i665  
or	eax,2048			;;; i763  
mov	d[ebp-40],eax			;;; i670  
; 
; [2278] CASE $$TRUNCATE				: cw = cw | 0x0C00  
jmp	end.select.00F8.xst			;;; i69 
case.00F8.0003.xst: 
mov	eax,3			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F8.0004.xst			;;; i71 
mov	eax,d[ebp-40]			;;; i665  
or	eax,3072			;;; i763  
mov	d[ebp-40],eax			;;; i670  
; 
; [2279] CASE ELSE							: RETURN ($$TRUE)  
jmp	end.select.00F8.xst			;;; i69 
case.00F8.0004.xst: 
mov	eax,-1			;;; i659 
jmp	end.func20.xst			;;; i258 
; 
; [2280] END SELECT 
end.select.00F8.xst:  
; 
; [2281] XstSetFPUControlWord (cw)  
push	[ebp-40]			;;; i674a 
call	func1E.xst			;;; i619b 
; 
; [2282] RETURN cwLast  
mov	eax,d[ebp-44]			;;; i665  
jmp	end.func20.xst			;;; i258 
; 
; [2284] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XstSetFPURounding.xst:  ;;; Function end label for Assembly Programmers.  
end.func20.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	4			;;; i111a 
