; [2295] FUNCTION  USHORT XstSetFPUPrecision (mode) 
.code 
; 
#ifdef XstSetFPUPrecision.mode  
#undef XstSetFPUPrecision.mode  
#endif  
#define XstSetFPUPrecision.mode ebp+8	; exposes function argument 'mode'  
; 
align 16  
_XstSetFPUPrecision@4:  
;  *****  
;  *****  FUNCTION  XstSetFPUPrecision ()  *****  
;  *****  
func1F.xst: 
push	ebp			;;; i112 
mov	ebp,esp		;;; i113 
sub	esp,8			;;; i114  
push	esi			;;; save esi 
push	edi			;;; save edi 
push	ebx			;;; save ebx 
sub esp,16      ;;; reserved for unwind handler 
; 
;	#### Begin Local Initialization Code #### 
xor	eax,eax		;;; .  
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
;	#### End Local Initialization Code #### 
; 
;	################################################################################  
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###  
;	### code above, the first 'sub esp,____' line below must be uncommented      ###  
;	### and the second must be either deleted or commented out.                  ###  
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###  
;	################################################################################  
; 
;	sub esp,220 
sub	esp,192			;;; i114a 
; 
funcBody1F.xst: 
; 
; [2297] ' The PC field (bits 9 and 8) or Precision Control 
; 
; [2298] ' determines to what precision the FPU rounds results  
; 
; [2299] ' after each arithmetic instruction in one of three ways:  
; 
; [2301] ' 00 = 24 bits (REAL4) 
; 
; [2302] ' 01 = Not used  
; 
; [2303] ' 10 = 53 bits (REAL8) 
; 
; [2304] ' 11 = 64 bits (REAL10) (this is the initialized state)  
; 
; [2305] ' note : XBLite loads msvcrt.lib on startup, which in turn,  
; 
; [2306] '        initializes the FPU precision to 53-bit mode. 
; 
; [2308] '$$24_BITS = 0 
; 
; [2309] '$$53_BITS = 1 
; 
; [2310] '$$64_BITS = 2 
; 
; [2312] USHORT cw, cwLast  
#ifdef XstSetFPUPrecision.cw  
#undef XstSetFPUPrecision.cw  
#endif  
#define XstSetFPUPrecision.cw ebp-40	; exposes local variable 'cw'  
; 
#ifdef XstSetFPUPrecision.cwLast  
#undef XstSetFPUPrecision.cwLast  
#endif  
#define XstSetFPUPrecision.cwLast ebp-44	; exposes local variable 'cwLast'  
; 
; 
; [2314] cw = XstGetFPUControlWord () 
call	func1D.xst			;;; i619b 
mov	d[ebp-40],eax			;;; i670  
; 
; [2315] cwLast = cw  
mov	eax,d[ebp-40]			;;; i665  
mov	d[ebp-44],eax			;;; i670  
; 
; [2316] cw = cw & 0xFCFF' clear bits 8 - 9 
mov	eax,d[ebp-40]			;;; i665  
and	eax,64767			;;; i769  
mov	d[ebp-40],eax			;;; i670  
; 
; [2317] SELECT CASE mode 
mov	eax,d[ebp+8]			;;; i665 
; .select1F.00F9 = ebp-48	; internal variable 
mov	d[ebp-48],eax			;;; i670  
; 
; [2318] CASE $$24_BITS 				: 
mov	eax,0			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F9.0001.xst			;;; i71 
; 
; [2319] CASE $$53_BITS				: cw = cw | 0x0200 
jmp	end.select.00F9.xst			;;; i69 
case.00F9.0001.xst: 
mov	eax,1			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F9.0002.xst			;;; i71 
mov	eax,d[ebp-40]			;;; i665  
or	eax,512			;;; i763 
mov	d[ebp-40],eax			;;; i670  
; 
; [2320] CASE $$64_BITS				: cw = cw | 0x0300 
jmp	end.select.00F9.xst			;;; i69 
case.00F9.0002.xst: 
mov	eax,2			;;; i659  
mov	ebx,d[ebp-48]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.00F9.0003.xst			;;; i71 
mov	eax,d[ebp-40]			;;; i665  
or	eax,768			;;; i763 
mov	d[ebp-40],eax			;;; i670  
; 
; [2321] CASE ELSE							: RETURN ($$TRUE)  
jmp	end.select.00F9.xst			;;; i69 
case.00F9.0003.xst: 
mov	eax,-1			;;; i659 
jmp	end.func1F.xst			;;; i258 
; 
; [2322] END SELECT 
end.select.00F9.xst:  
; 
; [2323] XstSetFPUControlWord (cw)  
push	[ebp-40]			;;; i674a 
call	func1E.xst			;;; i619b 
; 
; [2324] RETURN cwLast  
mov	eax,d[ebp-44]			;;; i665  
jmp	end.func1F.xst			;;; i258 
; 
; [2326] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XstSetFPUPrecision.xst:  ;;; Function end label for Assembly Programmers. 
end.func1F.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	4			;;; i111a 
