; [3392] FUNCTION  XstSystemExceptionToException (sysException, exception)  
.code 
; 
#ifdef XstSystemExceptionToException.sysException 
#undef XstSystemExceptionToException.sysException 
#endif  
#define XstSystemExceptionToException.sysException ebp+8	; exposes function argument 'sysException' 
; 
; 
#ifdef XstSystemExceptionToException.exception  
#undef XstSystemExceptionToException.exception  
#endif  
#define XstSystemExceptionToException.exception ebp+12	; exposes function argument 'exception'  
; 
align 16  
_XstSystemExceptionToException@8: 
;  *****  
;  *****  FUNCTION  XstSystemExceptionToException ()  ***** 
;  *****  
func37.xst: 
push	ebp			;;; i112 
mov	ebp,esp		;;; i113 
sub	esp,8			;;; i114  
push	esi			;;; save esi 
push	edi			;;; save edi 
push	ebx			;;; save ebx 
sub esp,16      ;;; reserved for unwind handler 
; 
;	#### Begin Local Initialization Code #### 
xor	eax,eax		;;; .  
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
;	#### End Local Initialization Code #### 
; 
;	################################################################################  
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###  
;	### code above, the first 'sub esp,____' line below must be uncommented      ###  
;	### and the second must be either deleted or commented out.                  ###  
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###  
;	################################################################################  
; 
;	sub esp,220 
sub	esp,200			;;; i114a 
; 
funcBody37.xst: 
; 
; [3393] SHARED exception$[]  
; 
; [3395] IFZ exception$[] THEN InitExceptionArray() 
mov	eax,d[%%%exception$.xst]			;;; i663a  
test	eax,eax			;;; i194 
jnz	>> else.012C.xst			;;; i195 
call	func41.xst			;;; i619b 
else.012C.xst:  
end.if.012C.xst:  
; 
; [3397] IF sysException & $$ExceptionCodeUser THEN 
mov	eax,d[ebp+8]			;;; i665 
and	eax,536870912			;;; i769  
test	eax,eax			;;; i220 
jz	>> else.012D.xst			;;; i221  
; 
; [3398] exception = sysException & 0x0FFFFFFF  
mov	eax,d[ebp+8]			;;; i665 
and	eax,268435455			;;; i769  
mov	d[ebp+12],eax			;;; i670  
; 
; [3399] IF exception > UBOUND(exception$[]) THEN exception = $$ExceptionUnknown: RETURN $$TRUE 
mov	eax,d[%%%exception$.xst]			;;; i663a  
test	eax,eax			;;; i593 
jz	> A.282			;;; i594 
mov	eax,d[eax-8]			;;; i595 
A.282:  
dec	eax			;;; i596  
mov	ebx,d[ebp+12]			;;; i665  
cmp	eax,ebx			;;; i684a 
jge	>> else.012E.xst			;;; i219 
mov	eax,17			;;; i659 
mov	d[ebp+12],eax			;;; i670  
mov	eax,-1			;;; i659 
jmp	end.func37.xst			;;; i258 
else.012E.xst:  
end.if.012E.xst:  
; 
; [3400] RETURN 
xor	eax,eax			;;; i862  
jmp	end.func37.xst			;;; i258 
; 
; [3401] END IF 
else.012D.xst:  
end.if.012D.xst:  
; 
; [3403] SELECT CASE sysException 
mov	eax,d[ebp+8]			;;; i665 
; .select37.012F = ebp-40	; internal variable 
mov	d[ebp-40],eax			;;; i670  
; 
; [3404] CASE $$EXCEPTION_ACCESS_VIOLATION					: exception = $$ExceptionSegmentViolation  
mov	eax,-1073741819			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0001.xst			;;; i71 
mov	eax,1			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3405] CASE $$EXCEPTION_ARRAY_BOUNDS_EXCEEDED		: exception = $$ExceptionOutOfBounds 
jmp	end.select.012F.xst			;;; i69 
case.012F.0001.xst: 
mov	eax,-1073741684			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0002.xst			;;; i71 
mov	eax,2			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3406] CASE $$EXCEPTION_BREAKPOINT								: exception = $$ExceptionBreakpoint 
jmp	end.select.012F.xst			;;; i69 
case.012F.0002.xst: 
mov	eax,-2147483645			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0003.xst			;;; i71 
mov	eax,3			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3407] CASE $$EXCEPTION_CONTROL_C_EXIT						: exception = $$ExceptionBreakKey 
jmp	end.select.012F.xst			;;; i69 
case.012F.0003.xst: 
mov	eax,-1073741510			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0004.xst			;;; i71 
mov	eax,4			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3408] CASE $$EXCEPTION_DATATYPE_MISALIGNMENT		: exception = $$ExceptionAlignment 
jmp	end.select.012F.xst			;;; i69 
case.012F.0004.xst: 
mov	eax,-2147483646			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0005.xst			;;; i71 
mov	eax,5			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3409] CASE $$EXCEPTION_FLOAT_DENORMAL_OPERAND		: exception = $$ExceptionDenormal 
jmp	end.select.012F.xst			;;; i69 
case.012F.0005.xst: 
mov	eax,-1073741683			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0006.xst			;;; i71 
mov	eax,6			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3410] CASE $$EXCEPTION_FLOAT_DIVIDE_BY_ZERO			: exception = $$ExceptionFloatDivideByZero 
jmp	end.select.012F.xst			;;; i69 
case.012F.0006.xst: 
mov	eax,-1073741682			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0007.xst			;;; i71 
mov	eax,7			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3411] CASE $$EXCEPTION_FLOAT_INEXACT_RESULT			: exception = $$ExceptionPrecision 
jmp	end.select.012F.xst			;;; i69 
case.012F.0007.xst: 
mov	eax,-1073741681			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0008.xst			;;; i71 
mov	eax,20			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3412] CASE $$EXCEPTION_FLOAT_INVALID_OPERATION	: exception = $$ExceptionInvalidOperation 
jmp	end.select.012F.xst			;;; i69 
case.012F.0008.xst: 
mov	eax,-1073741680			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0009.xst			;;; i71 
mov	eax,8			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3413] CASE $$EXCEPTION_FLOAT_OVERFLOW						: exception = $$ExceptionFloatOverflow  
jmp	end.select.012F.xst			;;; i69 
case.012F.0009.xst: 
mov	eax,-1073741679			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.000A.xst			;;; i71 
mov	eax,9			;;; i659  
mov	d[ebp+12],eax			;;; i670  
; 
; [3414] CASE $$EXCEPTION_FLOAT_STACK_CHECK				: exception = $$ExceptionStackCheck  
jmp	end.select.012F.xst			;;; i69 
case.012F.000A.xst: 
mov	eax,-1073741678			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.000B.xst			;;; i71 
mov	eax,10			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3415] CASE $$EXCEPTION_FLOAT_UNDERFLOW					: exception = $$ExceptionUnderflow  
jmp	end.select.012F.xst			;;; i69 
case.012F.000B.xst: 
mov	eax,-1073741677			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.000C.xst			;;; i71 
mov	eax,11			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3416] CASE $$EXCEPTION_GUARD_PAGE								: exception = $$ExceptionGuardPage  
jmp	end.select.012F.xst			;;; i69 
case.012F.000C.xst: 
mov	eax,-2147483647			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.000D.xst			;;; i71 
mov	eax,21			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3417] CASE $$EXCEPTION_ILLEGAL_INSTRUCTION			: exception = $$ExceptionInvalidInstruction 
jmp	end.select.012F.xst			;;; i69 
case.012F.000D.xst: 
mov	eax,-1073741795			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.000E.xst			;;; i71 
mov	eax,12			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3418] CASE $$EXCEPTION_IN_PAGE_ERROR						: exception = $$ExceptionInPage  
jmp	end.select.012F.xst			;;; i69 
case.012F.000E.xst: 
mov	eax,-1073741818			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.000F.xst			;;; i71 
mov	eax,22			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3419] CASE $$EXCEPTION_INT_DIVIDE_BY_ZERO				: exception = $$ExceptionIntDivideByZero  
jmp	end.select.012F.xst			;;; i69 
case.012F.000F.xst: 
mov	eax,-1073741676			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0010.xst			;;; i71 
mov	eax,18			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3420] CASE $$EXCEPTION_INT_OVERFLOW							: exception = $$ExceptionIntOverflow 
jmp	end.select.012F.xst			;;; i69 
case.012F.0010.xst: 
mov	eax,-1073741675			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0011.xst			;;; i71 
mov	eax,19			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3421] CASE $$EXCEPTION_INVALID_DISPOSITION      : exception = $$ExceptionDisposition 
jmp	end.select.012F.xst			;;; i69 
case.012F.0011.xst: 
mov	eax,-1073741786			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0012.xst			;;; i71 
mov	eax,23			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3422] CASE $$EXCEPTION_NONCONTINUABLE_EXCEPTION : exception = $$ExceptionNoncontinuable  
jmp	end.select.012F.xst			;;; i69 
case.012F.0012.xst: 
mov	eax,-1073741787			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0013.xst			;;; i71 
mov	eax,24			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3423] CASE $$EXCEPTION_PRIV_INSTRUCTION					: exception = $$ExceptionPrivilege 
jmp	end.select.012F.xst			;;; i69 
case.012F.0013.xst: 
mov	eax,-1073741674			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0014.xst			;;; i71 
mov	eax,13			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3424] CASE $$EXCEPTION_SINGLE_STEP							: exception = $$ExceptionSingleStep 
jmp	end.select.012F.xst			;;; i69 
case.012F.0014.xst: 
mov	eax,-2147483644			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0015.xst			;;; i71 
mov	eax,25			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3425] CASE $$EXCEPTION_STACK_OVERFLOW						: exception = $$ExceptionStackOverflow  
jmp	end.select.012F.xst			;;; i69 
case.012F.0015.xst: 
mov	eax,-1073741571			;;; i657  
mov	ebx,d[ebp-40]			;;; i665  
cmp	eax,ebx			;;; i684a 
jne	>> case.012F.0016.xst			;;; i71 
mov	eax,14			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3426] CASE ELSE  
jmp	end.select.012F.xst			;;; i69 
case.012F.0016.xst: 
; 
; [3427] exception = $$ExceptionUnknown 
mov	eax,17			;;; i659 
mov	d[ebp+12],eax			;;; i670  
; 
; [3428] RETURN $$TRUE  
mov	eax,-1			;;; i659 
jmp	end.func37.xst			;;; i258 
; 
; [3429] END SELECT 
end.select.012F.xst:  
; 
; [3430] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XstSystemExceptionToException.xst:  ;;; Function end label for Assembly Programmers.  
end.func37.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	8			;;; i111a 
