; 
; [3] ' ####################  Max Reason  
; 
; [4] ' #####  PROLOG  #####  copyright 1988-2003 
; 
; [5] ' ####################  XBLite standard function library  
; 
; [7] ' Xst is the XBlite standard function library 
; 
; [8] ' which is included as an object library  
; 
; [9] ' within xb.dll 
; 
; [10] ' ---  
; 
; [11] ' Xst now contains the minimum number of functions 
; 
; [12] ' required to build/compile/run XBLite programs. 
; 
; [13] ' Many of the functions have been moved to 
; 
; [14] ' another external library, Xsx. 
; 
; [15] ' ---  
; 
; [16] ' subject to LGPL license - see LGPL_License.txt 
; 
; [17] ' maxreason@maxreason.com  
; 
; [18] ' ---  
; 
; [19] ' XBLite modifications by David Szafranski 2002-2007 
; 
; [20] ' david.szafranski@gmail.com 
; 
; [21] '  
; 
; [22] ' 11/2003 - New exception routines by Ken Minogue  
; 
; [23] ' - XstExceptionNameToNumber() 
; 
; [24] ' - XstRaiseException()  
; 
; [25] ' - XstRegisterException() 
; 
; [26] '  
; 
; [27] ' 01/2004  
; 
; [28] ' - Moved IO console functions to an external library xio. 
; 
; [29] '	- Moved XxxFormat$ and ValidFormat to external library.  
; 
; [30] '	- Removed use of INCHR intrinsic from within Xst library (substituted INSTR).  
; 
; [31] '	- Removed use of LEFT$ intrinsic from within Xst library (substituted MID$). 
; 
; [32] '	- Removed use of RCLIP$/LCLIP$ intrinsics from within Xst library (substituted MID$).  
; 
; [33] '  
; 
; [34] ' 03/2004  
; 
; [35] ' - Added XstStringToLongDouble function for LONGDOUBLE type support.  
; 
; [36] ' - Added XstLongDoubleToString$ function. 
; 
; [37] ' - Added FPU control word functions.  
; 
; [38] ' - Added FP classification functions for LONGDOUBLE type. 
; 
; [39] ' - Modified XxxInline$() so that CRLF characters are not returned in string.  
; 
; [40] '  
; 
; [41] ' 06/2004  
; 
; [42] ' - Modified XxxInline$(), added FlushConsoleInputBuffer().  
; 
; [43] '  
; 
; [44] ' 05/2005  
; 
; [45] ' - Modified include files 
; 
; [46] '  
; 
; [47] ' v0.052 07/2005 
; 
; [48] ' - fixed bug in XstLongDoubleToString$ to print trailing zeros correctly. 
; 
; [49] '  
; 
; [50] ' v0.053 11 October 2005 
; 
; [51] ' - Modified inline asm to GoAsm syntax  
; 
; [52] '  
; 
; [53] ' v0.054 18 October 2005 
; 
; [54] ' - Moved ValidFormat and XxxFormat$ functions into xblib.lib (for FORMAT$ support)  
; 
; [55] '  
; 
; [56] ' v0.055 19 October 2005 
; 
; [57] ' - Moved DllMain from xlib.asm to be emmitted from xcowlite.  
; 
; [58] '  
; 
; [59] ' v0.056 6 December 2005 
; 
; [60] ' - moved exception$[] intialization from InitProgram to InitExceptionArray. 
; 
; [61] ' - modified InitProgram, XstSystemErrorToError, XstSystemErrorNumberToName, 
; 
; [62] '   and XstErrorNumberToName. System errors are now placed in the high word  
; 
; [63] '   of xblite error values, while xblite errors are in the low word. This was done 
; 
; [64] '   so that arrays #OSERROR$[] and #OSTOXERROR$[] are no longer needed.  
; 
; [65] '   The only drawback to this is that XstErrorNameToNumber() will not work on system errors. 
; 
; [67] ' v0.057 21 February 2006  
; 
; [68] ' - changed inline assembly ? to ASM 
; 
; [70] ' v0.058 11 February 2007  
; 
; [71] '	- Eliminated InitProgram 
; 
; [72] ' - Moved XstGetException () and XstSetException () to the assembly language routines  
; 
; [73] ' - Removed erroneous uses of EXTERNAL errno 
; 
; [75] ' v0.059 26 April 2007 
; 
; [76] ' - Moved all exception functions to Xsx library 
; 
; [77] ' - Moved XstCenterWindow, LOWORD, HIWORD, MAKELONG, and RGB to Xsx library. 
; 
; [78] ' - Modified XxxOpen or XxxWrite to intialize the console and DIM fileinfo[] array 
; 
; [79] ' - Removed unneeded .consoleGrid element from FILE type and modified XxxOpen, XxxClose. 
; 
; [80] ' - Added exported functions Xmalloc, Xrealloc, Xcalloc, and Xfree.  
; 
; [82] ' v0.069 21 August 2009  
; 
; [83] ' - restored all exception related functions to Xst library. 
; 
; [84] ' - restored Xit().  
; 
; [86] ' v0.070 28 July 2010  
; 
; [87] ' - Ken Minogue has rewritten the exception handling functions, XstTry() and 
; 
; [88] '   others to improve and streamline the exception handling process. 
; 
; [90] PROGRAM	"xst"  
; 
; [91] VERSION	"0.070"  
; 
; [93] IMPORT  "gdi32.dec"  
.code 
jmp	%_StartLibrary_xst			;;; i36a 
PrologCode.xst: 
push	ebp			;;; i38  
mov	ebp,esp			;;; i39 
sub	esp,256			;;; i40 
; 
; [94] IMPORT	"user32"  
mov	eax,addr @_string.002C.xst			;;; i663 
push	eax			;;; i40a 
call	_XxxXstLoadLibrary@4			;;; i40b  
; 
; [95] IMPORT	"kernel32"  
mov	eax,addr @_string.002D.xst			;;; i663 
push	eax			;;; i40a 
call	_XxxXstLoadLibrary@4			;;; i40b  
; 
; [97] ' ********************************************** 
; 
; [98] ' *****  Standard Library COMPOSITE TYPES  ***** 
; 
; [99] ' ********************************************** 
; 
; [100] ' 
; 
; [101] ' 
; 
; [102] ' 
; 
; [103] TYPE FILE 
; 
; [104] STRING*112   .fileName  
; 
; [105] XLONG        .fileHandle  
; 
; [106] XLONG        .entries 
; 
; [107] END TYPE  
; 
; [108] ' 
; 
; [109] TYPE LOCK 
; 
; [110] XLONG        .file  
; 
; [111] XLONG        .sfile 
; 
; [112] GIANT        .offset  
; 
; [113] GIANT        .length  
; 
; [114] GIANT        .end 
; 
; [115] END TYPE  
; 
; [117] TYPE EXCEPTION_REGISTRATION 
; 
; [118] ULONG	.prev'pointer to EXCEPTION_REGISTRATION for previous handler in SEH chain 
; 
; [119] ULONG	.handler'address of exception handler (XxxHandler() or XxxUnwinder()) 
; 
; [120] ULONG	.ebp'ebp for function that calls XstTry() 
; 
; [121] ULONG	.exSub'address of exception handler SUB 
; 
; [122] ULONG	.exData'address of EXCEPTION_DATA passed to XstTry()  
; 
; [123] END TYPE  
; 
; [124] ' 
; 
; [125] EXPORT  
; 
; [126] ' 
; 
; [127] TYPE TBYTE  
; 
; [128] UNION 
; 
; [129] UBYTE 			.ub[11]  
; 
; [130] USHORT			.us[5] 
; 
; [131] LONGDOUBLE 	.ld 
; 
; [132] END UNION 
; 
; [133] END TYPE  
; 
; [135] TYPE EXCEPTION_DATA 
; 
; [136] XLONG	.code 
; 
; [137] XLONG	.type 
; 
; [138] XLONG	.flags  
; 
; [139] XLONG	.address  
; 
; [140] XLONG	.response 
; 
; [141] XLONG	.info[14] 
; 
; [142] END TYPE  
; 
; [143] ' 
; 
; [144] ' 
; 
; [145] ' ****************************************  
; 
; [146] ' *****  Standard Library Functions  *****  
; 
; [147] ' ****************************************  
; 
; [148] ' 
; 
; [149] ' system functions, error functions, exception functions  
; 
; [150] ' 
; 
; [151] DECLARE FUNCTION  Xst                            () 
; 
; [152] DECLARE FUNCTION  XstVersion$                    () 
; 
; [153] DECLARE FUNCTION  XstErrorNameToNumber           (error$, @error) 
; 
; [154] DECLARE FUNCTION  XstErrorNumberToName           (error, @error$) 
; 
; [155] DECLARE FUNCTION  XstSystemErrorNumberToName     (sysError, @sysError$) 
; 
; [156] DECLARE FUNCTION  XstSystemErrorToError          (sysError, error)  
; 
; [157] DECLARE FUNCTION  XstGetSystemError              (sysError) 
; 
; [158] DECLARE FUNCTION  XstSetSystemError              (sysError) 
; 
; [159] DECLARE FUNCTION  XstGetEnvironmentVariable      (@name$, @value$)  
; 
; [160] ' 
; 
; [161] ' file functions  
; 
; [162] ' 
; 
; [163] DECLARE FUNCTION  XstFileToSystemFile            (fileNumber, @systemFileNumber)  
; 
; [164] DECLARE FUNCTION  XstLockFileSection             (fileNumber, mode, offset$$, length$$) 
; 
; [165] DECLARE FUNCTION  XstUnlockFileSection           (fileNumber, mode, offset$$, length$$) 
; 
; [166] DECLARE FUNCTION  XstPathString$                 (path$)  
; 
; [167] ' 
; 
; [168] ' LONGDOUBLE support functions  
; 
; [169] ' 
; 
; [170] DECLARE FUNCTION  USHORT FPClassifyL             (LONGDOUBLE x) 
; 
; [171] DECLARE FUNCTION  IsFiniteL                      (LONGDOUBLE x) 
; 
; [172] DECLARE FUNCTION  IsInfL                         (LONGDOUBLE x) 
; 
; [173] DECLARE FUNCTION  IsNanL                         (LONGDOUBLE x) 
; 
; [174] DECLARE FUNCTION  IsNormalL                      (LONGDOUBLE x) 
; 
; [175] DECLARE FUNCTION  IsSubNormalL                   (LONGDOUBLE x) 
; 
; [176] DECLARE FUNCTION  IsZeroL                        (LONGDOUBLE x) 
; 
; [177] DECLARE FUNCTION  SignBitL                       (LONGDOUBLE x) 
; 
; [178] DECLARE FUNCTION  XstStringToLongDouble          (text$, start, @after, @rtype, LONGDOUBLE value) 
; 
; [179] DECLARE FUNCTION  XstLongDoubleToString$         (LONGDOUBLE ld, maxDigits, expChar, prefixChar)  
; 
; [180] ' 
; 
; [181] ' xlib functions  
; 
; [182] ' 
; 
; [183] EXTERNAL FUNCTION  XstStringToNumber             (s$, startOff, afterOff, rtype, value$$) 
; 
; [184] EXTERNAL FUNCTION  XstFindMemoryMatch            (addrStart, addrAfter, addrMatch, minLength, maxLength)  
; 
; [185] ' 
; 
; [186] ' misc functions  
; 
; [187] ' 
; 
; [188] DECLARE FUNCTION  XxxXstFreeLibrary              (lib$, handle) 
; 
; [189] DECLARE FUNCTION  XxxXstLoadLibrary              (lib$) 
; 
; [190] ' 
; 
; [191] ' FPU control word functions  
; 
; [192] ' 
; 
; [193] DECLARE FUNCTION  USHORT XstEnableFPExceptions   () 
; 
; [194] DECLARE FUNCTION  USHORT XstGetFPUControlWord    () 
; 
; [195] DECLARE FUNCTION  USHORT XstSetFPUControlWord    (USHORT cw)  
; 
; [196] DECLARE FUNCTION  USHORT XstSetFPUPrecision      (mode) 
; 
; [197] DECLARE FUNCTION  USHORT XstSetFPURounding       (mode) 
; 
; [198] ' 
; 
; [199] END EXPORT  
; 
; [200] ' 
; 
; [201] ' internal Xst functions  
; 
; [202] ' 
; 
; [203] INTERNAL FUNCTION  InvalidFileNumber             (fileNumber) 
; 
; [204] INTERNAL FUNCTION  GetLocaleDecimalPoint         () 
; 
; [205] INTERNAL FUNCTION  Init_POT_Tables               () 
; 
; [206] ' 
; 
; [207] ' intrinsic support functions 
; 
; [208] ' 
; 
; [209] EXPORT  
; 
; [210] DECLARE FUNCTION  XxxEof                         (fileNumber) 
; 
; [211] DECLARE FUNCTION  XxxWriteFile                   (fileNumber, addr, bytes, bytesWritten, overlapped)  
; 
; [212] DECLARE FUNCTION  XxxReadFile                    (fileNumber, addr, bytes, bytesRead, overlapped) 
; 
; [213] DECLARE FUNCTION  XxxClose                       (fileNumber) 
; 
; [214] DECLARE FUNCTION  XxxLof                         (fileNumber) 
; 
; [215] DECLARE FUNCTION  XxxOpen                        (fileName$, openMode)  
; 
; [216] DECLARE FUNCTION  XxxPof                         (fileNumber) 
; 
; [217] DECLARE FUNCTION  XxxInfile$                     (fileNumber) 
; 
; [218] DECLARE FUNCTION  XxxInline$                     (prompt$)  
; 
; [219] DECLARE FUNCTION  XxxSeek                        (fileNumber, position) 
; 
; [220] DECLARE FUNCTION  XxxShell                       (command$) 
; 
; [221] ' 
; 
; [222] ' exception handler initialization  
; 
; [223] ' 
; 
; [224] DECLARE FUNCTION  Xit                            (appStart) 
; 
; [225] DECLARE FUNCTION  InitErrorStringArrays          () 
; 
; [227] ' 
; 
; [228] ' exception functions 
; 
; [229] DECLARE FUNCTION  XstCauseException              (exception)  
; 
; [230] DECLARE FUNCTION  XstRaiseException              (exception, type, arguments[]) 
; 
; [231] DECLARE FUNCTION  XstExceptionNameToNumber       (exception$, exception)  
; 
; [232] DECLARE FUNCTION  XstExceptionNumberToName       (exception, @exception$) 
; 
; [233] DECLARE FUNCTION  XstSystemExceptionNumberToName (sysException, sysException$)  
; 
; [234] DECLARE FUNCTION  XstExceptionToSystemException  (exception, @sysException) 
; 
; [235] DECLARE FUNCTION  XstSystemExceptionToException  (sysException, exception)  
; 
; [236] DECLARE FUNCTION  XstRegisterException           (@exception$, @exception)  
; 
; [237] DECLARE FUNCTION  XstGetExceptionFunction        (@function)  
; 
; [238] DECLARE FUNCTION  XstSetExceptionFunction        (function) 
; 
; [239] DECLARE FUNCTION  XstTry                         (SUBADDR Try, SUBADDR Handler, EXCEPTION_DATA @exception)  
; 
; [240] DECLARE FUNCTION  XstGetException                (@exception) 
; 
; [241] DECLARE FUNCTION  XstGetExceptionInformation     (EXCEPTION_RECORD @exRec, CONTEXT @context)  
; 
; [243] END EXPORT  
; 
; [244] DECLARE CFUNCTION XxxHandler (EXCEPTION_RECORD ExRec, EXCEPTION_REGISTRATION ExReg, CONTEXT Context, pDispatcher) 
; 
; [245] DECLARE CFUNCTION XxxUnwinder (EXCEPTION_RECORD ExRec, EXCEPTION_REGISTRATION ExReg, CONTEXT Context, pDispatcher)  
; 
; [246] INTERNAL FUNCTION XxxCallExceptSub               (pExReg) 
; 
; [247] INTERNAL FUNCTION InitExceptionArray             () 
; 
; [248] EXPORT  
; 
; [249] ' 
; 
; [250] ' memory allocation functions 
; 
; [251] EXTERNAL FUNCTION Xcalloc                        (size) 
; 
; [252] EXTERNAL FUNCTION Xfree                          (ptr)  
; 
; [253] EXTERNAL FUNCTION Xmalloc                        (size) 
; 
; [254] EXTERNAL FUNCTION Xrealloc                       (size, address)  
; 
; [255] ' 
; 
; [256] ' 
; 
; [257] ' ****************************************  
; 
; [258] ' *****  Standard Library Constants  *****  
; 
; [259] ' ****************************************  
; 
; [260] ' 
; 
; [261] ' path slash characters (different for DOS/Windows vs UNIX) 
; 
; [262] ' 
; 
; [263] $$PathSlash$          = "\\"' Windows 
; 
; [264] $$PathSlash           = '\\'' Windows 
; 
; [265] ' This is the character that separates directories in environment-variables 
; 
; [266] ' (e.g. PATH).  
; 
; [267] $$PathSeparator				= ';'' Windows 
; 
; [268] $$PathSeparator$			= ";"' Windows 
; 
; [269] ' $$PathSlash$          = "/"       ' UNIX  
; 
; [270] ' $$PathSlash           = '/'       ' UNIX  
; 
; [271] '	$$PathSeparator				= ':'				' Unix  
; 
; [272] '	$$PathSeparator$			= ":"				' Unix  
; 
; [274] ' ********************************  
; 
; [275] ' *****  File I/O Constants  *****  for OPEN()  
; 
; [276] ' ********************************  
; 
; [277] ' 
; 
; [278] $$RD                  = 0x0000' read file 
; 
; [279] $$WR                  = 0x0001' write file  
; 
; [280] $$RW                  = 0x0002' read/write file 
; 
; [281] $$WRNEW               = 0x0003' write new file  
; 
; [282] $$RWNEW               = 0x0004' read/write new file 
; 
; [283] $$NOSHARE             = 0x0000' share file for none 
; 
; [284] $$RDSHARE             = 0x0010' share file for read 
; 
; [285] $$WRSHARE             = 0x0020' share file for write  
; 
; [286] $$RWSHARE             = 0x0030' share file for read & write 
; 
; [287] $$ALL                 = -1' CLOSE ($$ALL) 
; 
; [288] ' 
; 
; [289] ' ********************************  
; 
; [290] ' *****  Language Constants  *****  I/O, Kinds, DataTypes, Scope, etc...  
; 
; [291] ' ********************************  
; 
; [292] ' 
; 
; [293] $$ZERO                =  0  
; 
; [294] $$ONE                 =  1  
; 
; [295] $$ENDIAN              =  0  
; 
; [296] $$STDIN               =  0  
; 
; [297] $$STDOUT              =  1  
; 
; [298] $$STDERR              =  2  
; 
; [299] $$VOID                =  1  
; 
; [300] $$SBYTE               =  2  
; 
; [301] $$UBYTE               =  3  
; 
; [302] $$SSHORT              =  4  
; 
; [303] $$USHORT              =  5  
; 
; [304] $$SLONG               =  6  
; 
; [305] $$ULONG               =  7  
; 
; [306] $$XLONG               =  8  
; 
; [307] $$GOADDR              =  9  
; 
; [308] $$SUBADDR             = 10  
; 
; [309] $$FUNCADDR            = 11  
; 
; [310] $$GIANT               = 12  
; 
; [311] $$SINGLE              = 13  
; 
; [312] $$DOUBLE              = 14  
; 
; [313] $$LONGDOUBLE          = 15  
; 
; [314] $$ARRAY               = 16  
; 
; [315] $$ANY                 = 16  
; 
; [316] $$ETC                 = 17  
; 
; [317] $$VARARG              = 18  
; 
; [318] $$STRING              = 19  
; 
; [319] $$COMPOSITE           = 31  
; 
; [320] $$SCOMPLEX            = 32  
; 
; [321] $$DCOMPLEX            = 33  
; 
; [322] $$AUTO                =  0  
; 
; [323] $$AUTOX               =  1  
; 
; [324] $$STATIC              =  2  
; 
; [325] $$SHARED              =  3  
; 
; [326] $$EXTERNAL            =  4  
; 
; [327] $$ARGUMENT            =  7  
; 
; [329] ' FPU rounding modes  
; 
; [330] $$ROUND_NEAREST = 0 
; 
; [331] $$ROUND_DOWN = 1  
; 
; [332] $$ROUND_UP = 2  
; 
; [333] $$TRUNCATE = 3  
; 
; [335] ' FPU precision modes 
; 
; [336] $$24_BITS = 0 
; 
; [337] $$53_BITS = 1 
; 
; [338] $$64_BITS = 2 
; 
; [339] ' 
; 
; [340] ' FP Classification constants 
; 
; [341] $$FP_NAN		   = 0x0100 
; 
; [342] $$FP_NORMAL	   = 0x0400 
; 
; [343] $$FP_INFINITE	 = 0x0500' (FP_NAN | FP_NORMAL) 
; 
; [344] $$FP_ZERO		   = 0x4000  
; 
; [345] $$FP_SUBNORMAL = 0x4400' (FP_NORMAL | FP_ZERO)  
; 
; [346] ' 
; 
; [347] ' 
; 
; [348] ' **********************************  
; 
; [349] ' *****  Native Error Numbers  *****  
; 
; [350] ' **********************************  
; 
; [351] ' 
; 
; [352] ' "Native Error Numbers" are USHORT values composed of two parts: 
; 
; [353] '    1. ErrorObject in upper byte - object associated with error  
; 
; [354] '    2. ErrorNature in lower byte - nature of action or error 
; 
; [355] ' 
; 
; [356] $$ErrorObjectNone                =  0' or unknown 
; 
; [357] $$ErrorObjectData                =  1 
; 
; [358] $$ErrorObjectDisk                =  2 
; 
; [359] $$ErrorObjectFile                =  3 
; 
; [360] $$ErrorObjectFont                =  4 
; 
; [361] $$ErrorObjectGrid                =  5 
; 
; [362] $$ErrorObjectIcon                =  6 
; 
; [363] $$ErrorObjectName                =  7 
; 
; [364] $$ErrorObjectNode                =  8 
; 
; [365] $$ErrorObjectPipe                =  9 
; 
; [366] $$ErrorObjectUser                = 10 
; 
; [367] $$ErrorObjectArray               = 11 
; 
; [368] $$ErrorObjectImage               = 12 
; 
; [369] $$ErrorObjectMedia               = 13 
; 
; [370] $$ErrorObjectQueue               = 14 
; 
; [371] $$ErrorObjectStack               = 15 
; 
; [372] $$ErrorObjectTimer               = 16 
; 
; [373] $$ErrorObjectBuffer              = 17 
; 
; [374] $$ErrorObjectCursor              = 18 
; 
; [375] $$ErrorObjectDevice              = 19 
; 
; [376] $$ErrorObjectDriver              = 20 
; 
; [377] $$ErrorObjectMemory              = 21 
; 
; [378] $$ErrorObjectSocket              = 22 
; 
; [379] $$ErrorObjectString              = 23 
; 
; [380] $$ErrorObjectSystem              = 24 
; 
; [381] $$ErrorObjectThread              = 25 
; 
; [382] $$ErrorObjectWindow              = 26 
; 
; [383] $$ErrorObjectCommand             = 27 
; 
; [384] $$ErrorObjectDisplay             = 28 
; 
; [385] $$ErrorObjectLibrary             = 29 
; 
; [386] $$ErrorObjectMessage             = 30 
; 
; [387] $$ErrorObjectNetwork             = 31 
; 
; [388] $$ErrorObjectPrinter             = 32 
; 
; [389] $$ErrorObjectProcess             = 33 
; 
; [390] $$ErrorObjectProgram             = 34 
; 
; [391] $$ErrorObjectArgument            = 35 
; 
; [392] $$ErrorObjectComputer            = 36 
; 
; [393] $$ErrorObjectFunction            = 37 
; 
; [394] $$ErrorObjectIdentity            = 38 
; 
; [395] $$ErrorObjectPassword            = 39 
; 
; [396] $$ErrorObjectClipboard           = 40 
; 
; [397] $$ErrorObjectDirectory           = 41 
; 
; [398] $$ErrorObjectSemaphore           = 42 
; 
; [399] $$ErrorObjectStatement           = 43 
; 
; [400] $$ErrorObjectSystemRoutine       = 44 
; 
; [401] $$ErrorObjectSystemFunction      = 45 
; 
; [402] $$ErrorObjectSystemResource      = 46 
; 
; [403] $$ErrorObjectOperatingSystem     = 47 
; 
; [404] $$ErrorObjectIntegerLogicUnit    = 48 
; 
; [405] $$ErrorObjectFloatingPointUnit   = 49 
; 
; [406] ' 
; 
; [407] $$ErrorNatureNone                =  0 
; 
; [408] $$ErrorNatureBusy                =  1 
; 
; [409] $$ErrorNatureFull                =  2 
; 
; [410] $$ErrorNatureError               =  3 
; 
; [411] $$ErrorNatureEmpty               =  4 
; 
; [412] $$ErrorNatureReset               =  5 
; 
; [413] $$ErrorNatureExists              =  6 
; 
; [414] $$ErrorNatureFailed              =  7 
; 
; [415] $$ErrorNatureHalted              =  8 
; 
; [416] $$ErrorNatureExpired             =  9 
; 
; [417] $$ErrorNatureInvalid             = 10 
; 
; [418] $$ErrorNatureMissing             = 11 
; 
; [419] $$ErrorNatureTimeout             = 12 
; 
; [420] $$ErrorNatureTooMany             = 13 
; 
; [421] $$ErrorNatureUnknown             = 14 
; 
; [422] $$ErrorNatureBreakKey            = 15 
; 
; [423] $$ErrorNatureDeadlock            = 16 
; 
; [424] $$ErrorNatureDisabled            = 17 
; 
; [425] $$ErrorNatureNotEmpty            = 18 
; 
; [426] $$ErrorNatureObsolete            = 19 
; 
; [427] $$ErrorNatureOverflow            = 20 
; 
; [428] $$ErrorNatureTooLarge            = 21 
; 
; [429] $$ErrorNatureTooSmall            = 22 
; 
; [430] $$ErrorNatureAbandoned           = 23 
; 
; [431] $$ErrorNatureAvailable           = 24 
; 
; [432] $$ErrorNatureDuplicate           = 25 
; 
; [433] $$ErrorNatureExhausted           = 26 
; 
; [434] $$ErrorNaturePrivilege           = 27 
; 
; [435] $$ErrorNatureUndefined           = 28 
; 
; [436] $$ErrorNatureUnderflow           = 29 
; 
; [437] $$ErrorNatureAllocation          = 30 
; 
; [438] $$ErrorNatureBreakpoint          = 31 
; 
; [439] $$ErrorNatureContention          = 32 
; 
; [440] $$ErrorNaturePermission          = 33 
; 
; [441] $$ErrorNatureTerminated          = 34 
; 
; [442] $$ErrorNatureUndeclared          = 35 
; 
; [443] $$ErrorNatureUnexpected          = 36 
; 
; [444] $$ErrorNatureWouldBlock          = 37 
; 
; [445] $$ErrorNatureInterrupted         = 38 
; 
; [446] $$ErrorNatureMalfunction         = 39 
; 
; [447] $$ErrorNatureNonexistent         = 40 
; 
; [448] $$ErrorNatureUnavailable         = 41 
; 
; [449] $$ErrorNatureUnspecified         = 42 
; 
; [450] $$ErrorNatureDisconnected        = 43 
; 
; [451] $$ErrorNatureDivideByZero        = 44 
; 
; [452] $$ErrorNatureIncompatible        = 45 
; 
; [453] $$ErrorNatureNotConnected        = 46 
; 
; [454] $$ErrorNatureLimitExceeded       = 47 
; 
; [455] $$ErrorNatureNotInitialized      = 48 
; 
; [456] $$ErrorNatureHigherDimension     = 49 
; 
; [457] $$ErrorNatureLowestDimension     = 50 
; 
; [458] $$ErrorNatureCannotInitialize    = 51 
; 
; [459] $$ErrorNatureInitializeFailed    = 52 
; 
; [460] $$ErrorNatureAlreadyInitialized  = 53 
; 
; [461] $$ErrorNatureInvalidAccess       = 54 
; 
; [462] $$ErrorNatureInvalidAddress      = 55 
; 
; [463] $$ErrorNatureInvalidAlignment    = 56 
; 
; [464] $$ErrorNatureInvalidArgument     = 57 
; 
; [465] $$ErrorNatureInvalidCheck        = 58 
; 
; [466] $$ErrorNatureInvalidCoordinates  = 59 
; 
; [467] $$ErrorNatureInvalidCommand      = 60 
; 
; [468] $$ErrorNatureInvalidData         = 61 
; 
; [469] $$ErrorNatureInvalidDimension    = 62 
; 
; [470] $$ErrorNatureInvalidEntry        = 63 
; 
; [471] $$ErrorNatureInvalidFormat       = 64 
; 
; [472] $$ErrorNatureInvalidKind         = 65 
; 
; [473] $$ErrorNatureInvalidIdentity     = 66 
; 
; [474] $$ErrorNatureInvalidInstruction  = 67 
; 
; [475] $$ErrorNatureInvalidLocation     = 68 
; 
; [476] $$ErrorNatureInvalidMessage      = 69 
; 
; [477] $$ErrorNatureInvalidName         = 70 
; 
; [478] $$ErrorNatureInvalidNode         = 71 
; 
; [479] $$ErrorNatureInvalidNumber       = 72 
; 
; [480] $$ErrorNatureInvalidOperand      = 73 
; 
; [481] $$ErrorNatureInvalidOperation    = 74 
; 
; [482] $$ErrorNatureInvalidReply        = 75 
; 
; [483] $$ErrorNatureInvalidRequest      = 76 
; 
; [484] $$ErrorNatureInvalidResult       = 77 
; 
; [485] $$ErrorNatureInvalidSelection    = 78 
; 
; [486] $$ErrorNatureInvalidSignature    = 79 
; 
; [487] $$ErrorNatureInvalidSize         = 80 
; 
; [488] $$ErrorNatureInvalidType         = 81 
; 
; [489] $$ErrorNatureInvalidValue        = 82 
; 
; [490] $$ErrorNatureInvalidVersion      = 83 
; 
; [491] $$ErrorNatureInvalidDistribution = 84 
; 
; [492] $$ErrorNatureInvalidMargin       = 85 
; 
; [494] ' 
; 
; [495] ' 
; 
; [496] ' ****************************************  
; 
; [497] ' *****  Native Exception Constants  *****  
; 
; [498] ' ****************************************  
; 
; [499] ' 
; 
; [500] $$ExceptionNone                  =  0 
; 
; [501] $$ExceptionSegmentViolation      =  1 
; 
; [502] $$ExceptionOutOfBounds           =  2' Do not change without changing in asm routines!  
; 
; [503] $$ExceptionBreakpoint            =  3 
; 
; [504] $$ExceptionBreakKey              =  4 
; 
; [505] $$ExceptionAlignment             =  5 
; 
; [506] $$ExceptionDenormal              =  6 
; 
; [507] $$ExceptionDivideByZero          =  7 
; 
; [508] $$ExceptionInvalidOperation      =  8 
; 
; [509] $$ExceptionOverflow              =  9 
; 
; [510] $$ExceptionStackCheck            = 10 
; 
; [511] $$ExceptionUnderflow             = 11 
; 
; [512] $$ExceptionInvalidInstruction    = 12 
; 
; [513] $$ExceptionPrivilege             = 13 
; 
; [514] $$ExceptionStackOverflow         = 14 
; 
; [515] $$ExceptionReserved              = 15 
; 
; [516] $$ExceptionTimer                 = 16 
; 
; [517] $$ExceptionUnknown               = 17 
; 
; [518] $$ExceptionIntDivideByZero       = 18 
; 
; [519] $$ExceptionIntOverflow           = 19' Do not change without changing in asm routines!  
; 
; [520] $$ExceptionPrecision             = 20 
; 
; [521] $$ExceptionGuardPage             = 21 
; 
; [522] $$ExceptionInPage                = 22 
; 
; [523] $$ExceptionDisposition           = 23 
; 
; [524] $$ExceptionNoncontinuable        = 24 
; 
; [525] $$ExceptionSingleStep            = 25 
; 
; [526] $$ExceptionMemoryAllocation      = 26' Do not change without changing in asm routines!  
; 
; [527] $$ExceptionNodeNotEmpty          = 27' Do not change without changing in asm routines!  
; 
; [528] $$ExceptionArrayDimension        = 28' Do not change without changing in asm routines!  
; 
; [529] $$ExceptionInvalidArgument       = 29' Do not change without changing in asm routines!  
; 
; [530] $$ExceptionIllegalReturn         = 30 
; 
; [531] $$ExceptionUpper                 = 30' dts - was 31???  
; 
; [532] $$ExceptionFloatDivideByZero     = $$ExceptionDivideByZero  
; 
; [533] $$ExceptionFloatOverflow         = $$ExceptionOverflow  
; 
; [534] ' 
; 
; [535] $$ExceptionTerminate             =  0 
; 
; [536] $$ExceptionContinue              = -1 
; 
; [537] $$ExceptionRetry                 = -2 
; 
; [538] $$ExceptionForward							 =  1  
; 
; [540] $$ExceptionCodeUser              = 0x20000000 
; 
; [542] $$ExceptionTypeInformation       = 0x40000000 
; 
; [543] $$ExceptionTypeWarning           = 0x80000000 
; 
; [544] $$ExceptionTypeError             = 0xC0000000 
; 
; [546] END EXPORT  
; 
; [548] $$DISPOSITION_DISMISS            = 0  
; 
; [549] $$DISPOSITION_CONTINUE_EXECUTION = $$DISPOSITION_DISMISS  
; 
; [550] $$DISPOSITION_CONTINUE_SEARCH    = 1  
; 
; [551] $$DISPOSITION_NESTED_EXCEPTION   = 2  
; 
; [552] $$DISPOSITION_COLLIDED_UNWIND    = 3  
; 
; [554] ' 
; 
; [555] ' 
; 
; [556] ' ####################  
; 
; [557] ' #####  Xst ()  #####  
; 
; [558] ' ####################  
; 
; [559] ' 
; 
; [560] ' 
; 
; [561] FUNCTION  Xst ()  
.code 
leave	;;; i160a 
ret				;;; i161 ;;; end prolog code 
%_StartLibrary_xst: 
call	func1.xst			;;; i162c  
ret	0			;;; i162d 
align 16  
_Xst@0: 
;  *****  
;  *****  FUNCTION  Xst ()  ***** 
;  *****  
func1.xst:  
push	ebp			;;; i112 
mov	ebp,esp		;;; i113 
sub	esp,8			;;; i114  
push	esi			;;; save esi 
push	edi			;;; save edi 
push	ebx			;;; save ebx 
sub esp,16      ;;; reserved for unwind handler 
call	%%%%initOnce.xst 
; 
;	#### Begin Local Initialization Code #### 
xor	eax,eax		;;; .  
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
push	eax			;;; .. 
;	#### End Local Initialization Code #### 
; 
;	################################################################################  
;	### *** IMPORTANT *** - If hand-optimizing by eliminating the initialization ###  
;	### code above, the first 'sub esp,____' line below must be uncommented      ###  
;	### and the second must be either deleted or commented out.                  ###  
;	### !!! Failure to do so will cause the resultant program to crash !!!       ###  
;	################################################################################  
; 
;	sub esp,220 
sub	esp,200			;;; i114a 
; 
funcBody1.xst:  
; 
; [562] SHARED FUNCADDR NtContinue (XLONG, XLONG) 
data section 'globals$shared' 
align	4 
%NtContinue.xst:	db 4 dup ? 
.code 
; 
; [564] STATIC  entry 
data section 'globals$statics'  
align	4 
%1%entry.xst:	db 4 dup ?  
.code 
; 
; [566] IF entry THEN RETURN  
mov	eax,d[%1%entry.xst]			;;; i663a 
test	eax,eax			;;; i220 
jz	>> else.0001.xst			;;; i221  
xor	eax,eax			;;; i862  
jmp	end.func1.xst			;;; i258  
else.0001.xst:  
end.if.0001.xst:  
; 
; [567] entry = $$TRUE  
mov	eax,-1			;;; i659 
mov	d[%1%entry.xst],eax			;;; i668  
; 
; [569] hlib = LoadLibraryA (&"ntdll.dll")  
#ifdef Xst.hlib 
#undef Xst.hlib 
#endif  
#define Xst.hlib ebp-40	; exposes local variable 'hlib' 
; 
; 
; [0] EXTERNAL FUNCTION LoadLibraryA (lpLibFileName)  
mov	eax,addr @_string.01E7.xst			;;; i642 
push	eax			;;; i667a  
call	_LoadLibraryA@4			;;; i619b  
mov	d[ebp-40],eax			;;; i670  
; 
; [570] NtContinue = GetProcAddress (hlib, &"NtContinue") 
; 
; [0] EXTERNAL FUNCTION GetProcAddress (hModule, lpProcName)  
mov	eax,addr @_string.01E8.xst			;;; i642 
push	eax			;;; i667a  
push	[ebp-40]			;;; i674a 
call	_GetProcAddress@8			;;; i619b  
mov	d[%NtContinue.xst],eax			;;; i668 
; 
; [572] ' initialize console  
; 
; [573] '	confile = XxxOpen ("CON:", $$RD)			' Create/reserve a console FILE entry in fileInfo[]  
; 
; [574] ' This does not create the Console window 
; 
; [575] ' For GUI programs, XstCreateConsole is used to 
; 
; [576] ' to allocate a console window. 
; 
; [577] END FUNCTION  
xor	eax,eax			;;; i862  
align 8 
end.Xst.xst:  ;;; Function end label for Assembly Programmers.  
end.func1.xst:  
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret						;;; i111d  
;-peep  
;  *****  
;  *****  END FUNCTION  Xst ()  ***** 
;  *****  
%%%%initOnce.xst: 
cmp d[%%%entered.xst],-1		;;; i117  
jne > A.4	;;; i117a 
ret			;;; i117b 
A.4:  
call	PrologCode.xst			;;; i118a 
mov esi,addr %_begin_external_data_xst  
mov edi,addr %_end_external_data_xst  
call %_ZeroMemory 
call	InitSharedComposites.xst			;;; i119  
mov	d[%%%entered.xst],-1  
ret				;;; i120 
data section 'xst$internals'  
align 4 
%%%entered.xst: 
db 4 dup ?  
.code 
; 
; [578] ' 
; 
; [579] ' 
; 
; [580] ' ############################  
; 
; [581] ' #####  XstVersion$ ()  #####  
; 
; [582] ' ############################  
; 
; [583] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstVersion$ ()  ***** 
;  *****  
; 
; [588] ' 
; 
; [589] ' 
; 
; [590] ' ##################################### 
; 
; [591] ' #####  XstErrorNameToNumber ()  ##### 
; 
; [592] ' ##################################### 
; 
; [593] ' 
; 
free.func3.xst: 
mov	esi,[ebp-52]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-68]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstErrorNameToNumber ()  *****  
;  *****  
; 
; [649] ' 
; 
; [650] ' 
; 
; [651] ' ##################################### 
; 
; [652] ' #####  XstErrorNumberToName ()  ##### 
; 
; [653] ' ##################################### 
; 
; [654] ' 
; 
free.func4.xst: 
mov	esi,[ebp-60]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-64]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstErrorNumberToName ()  *****  
;  *****  
; 
; [699] ' 
; 
; [700] ' 
; 
; [701] ' ########################################### 
; 
; [702] ' #####  XstSystemErrorNumberToName ()  ##### 
; 
; [703] ' ########################################### 
; 
; [704] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSystemErrorNumberToName ()  *****  
;  *****  
; 
; [719] ' 
; 
; [720] ' 
; 
; [721] ' ######################################  
; 
; [722] ' #####  XstSystemErrorToError ()  #####  
; 
; [723] ' ######################################  
; 
; [724] ' 
; 
; [725] ' Move system error to high word of error value.  
; 
; [726] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSystemErrorToError ()  ***** 
;  *****  
; 
; [740] ' 
; 
; [741] ' 
; 
; [742] ' ##################################  
; 
; [743] ' #####  XstGetSystemError ()  #####  
; 
; [744] ' ##################################  
; 
; [745] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstGetSystemError ()  ***** 
;  *****  
; 
; [749] ' 
; 
; [750] ' 
; 
; [751] ' ##################################  
; 
; [752] ' #####  XstSetSystemError ()  #####  
; 
; [753] ' ##################################  
; 
; [754] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSetSystemError ()  ***** 
;  *****  
; 
; [758] ' 
; 
; [759] ' 
; 
; [760] ' ##########################################  
; 
; [761] ' #####  XstGetEnvironmentVariable ()  #####  
; 
; [762] ' ##########################################  
; 
; [763] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstGetEnvironmentVariable ()  ***** 
;  *****  
; 
; [778] ' 
; 
; [779] ' 
; 
; [780] ' ####################################  
; 
; [781] ' #####  XstFileToSystemFile ()  #####  
; 
; [782] ' ####################################  
; 
; [783] ' 
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstFileToSystemFile ()  ***** 
;  *****  
; 
; [796] ' 
; 
; [797] ' 
; 
; [798] ' ################################### 
; 
; [799] ' #####  XstLockFileSection ()  ##### 
; 
; [800] ' ################################### 
; 
; [801] ' 
; 
free.funcB.xst: 
mov	esi,d[ebp-40]			;;; i665  
call	%_FreeArray			;;; i424 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstLockFileSection ()  *****  
;  *****  
; 
; [908] ' 
; 
; [909] ' 
; 
; [910] ' ##################################### 
; 
; [911] ' #####  XstUnlockFileSection ()  ##### 
; 
; [912] ' ##################################### 
; 
; [913] ' 
; 
free.funcC.xst: 
mov	esi,d[ebp-40]			;;; i665  
call	%_FreeArray			;;; i424 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstUnlockFileSection ()  *****  
;  *****  
; 
; [1014] '  
; 
; [1015] '  
; 
; [1016] ' ###############################  
; 
; [1017] ' #####  XstPathString$ ()  #####  
; 
; [1018] ' ###############################  
; 
; [1019] '  
; 
out.subD.0.xst: 
; 
; [1158] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XstPathString$.xst:  ;;; Function end label for Assembly Programmers. 
end.funcD.xst:  
mov ebx,[ebp-36]  
fs mov [0],ebx       ;;; remove unwind handler  
call free.funcD.xst 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	4			;;; i111a 
free.funcD.xst: 
mov	esi,[ebp-92]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-44]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-60]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-100]			;;; i665  
call	%____free			;;; i423 
mov	esi,[ebp-72]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-120]			;;; i665  
call	%____free			;;; i423 
mov	esi,[ebp-104]			;;; i665  
call	%____free			;;; i423 
mov	esi,[ebp-96]			;;; i665 
call	%____free			;;; i423 
mov	esi,[ebp-88]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstPathString$ ()  *****  
;  *****  
; 
; [1159] '  
; 
; [1160] '  
; 
; [1161] ' ################################## 
; 
; [1162] ' #####  XxxXstFreeLibrary ()  ##### 
; 
; [1163] ' ################################## 
; 
; [1164] '  
; 
free.func1A.xst:  
mov	esi,[ebp-52]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxXstFreeLibrary ()  ***** 
;  *****  
; 
; [1194] '  
; 
; [1195] '  
; 
; [1196] ' ################################## 
; 
; [1197] ' #####  XxxXstLoadLibrary ()  ##### 
; 
; [1198] ' ################################## 
; 
; [1199] '  
; 
out.sub1B.0.xst:  
; 
; [1260] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XxxXstLoadLibrary.xst:  ;;; Function end label for Assembly Programmers.  
end.func1B.xst: 
mov ebx,[ebp-36]  
fs mov [0],ebx       ;;; remove unwind handler  
call free.func1B.xst  
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	4			;;; i111a 
free.func1B.xst:  
mov	esi,[ebp-60]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxXstLoadLibrary ()  ***** 
;  *****  
; 
; [1261] '  
; 
; [1262] '  
; 
; [1263] ' ################################## 
; 
; [1264] ' #####  InvalidFileNumber ()  ##### 
; 
; [1265] ' ################################## 
; 
; [1266] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  InvalidFileNumber ()  ***** 
;  *****  
; 
; [1282] '  
; 
; [1283] '  
; 
; [1284] ' #######################  
; 
; [1285] ' #####  XxxEof ()  #####  
; 
; [1286] ' #######################  
; 
; [1287] '  
; 
; [1288] '  
; 
; [1289] '	Return TRUE if current file pointer is beyond the end of file  
; 
; [1290] '  
; 
; [1291] '	In:				fileNumber		File Number 
; 
; [1292] '	Out:			none--arg unchanged 
; 
; [1293] '	Return:		$$TRUE		file at EOF 
; 
; [1294] '						$$FALSE		file not at EOF  
; 
; [1295] '						$$TRUE		error (##ERROR is set)		**** this must be resolved  
; 
; [1296] '  
; 
; [1297] '	The return values of TRUE and -max are ambiguous if tested with  
; 
; [1298] '		"IF Eof(fileNumber) THEN".  User should test explicitely. 
; 
; [1299] '		(Note that action based on EOF is usually consistent with that for error.)  
; 
; [1300] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxEof ()  *****  
;  *****  
; 
; [1325] '  
; 
; [1326] '  
; 
; [1327] ' #############################  
; 
; [1328] ' #####  XxxWriteFile ()  #####  
; 
; [1329] ' #############################  
; 
; [1330] '  
; 
; [1331] '	In:				fileNumber		File Number 
; 
; [1332] '						buffer  
; 
; [1333] '						bytes					to be written 
; 
; [1334] '						bytesWritten  
; 
; [1335] '						overlapped		NULL  
; 
; [1336] '	Out:			none--arg unchanged 
; 
; [1337] '  
; 
; [1338] '	Valid on console grids for now 
; 
; [1339] '	xlibs.s calls XxxWriteFile() for stdout  
; 
; [1340] '  
; 
out.sub25.0.xst:  
; 
; [1372] SUB Initialize 
jmp	out.sub25.1.xst			;;; i262  
align 16  
%s%Initialize%25: 
; .sub25.0001 = ebp-68	; internal variable  
; 
; [1373] entry = $$TRUE 
mov	eax,-1			;;; i659 
mov	d[%25%entry.xst],eax			;;; i668 
; 
; [1374] IFZ fileInfo[] THEN  
mov	eax,d[%%%fileInfo.xst]			;;; i663a  
test	eax,eax			;;; i194 
jnz	>> else.007E.xst			;;; i195 
; 
; [1375] DIM fileInfo[15] 
sub	esp,64			;;; i430 
mov	eax,15			;;; i659 
mov	d[esp+16],eax			;;; i432  
mov	esi,d[%%%fileInfo.xst]			;;; i663a  
mov	d[esp],esi			;;; i433 
mov	d[esp+4],1			;;; i434 
mov	d[esp+8],-1064173448			;;; i435 
mov	d[esp+12],0			;;; i436  
call	%_DimArray			;;; i437  
add	esp,64			;;; i438 
mov	d[%%%fileInfo.xst],eax			;;; i668 
; 
; [1376] 'initialize console file as 1  
; 
; [1377] fileInfo[1].fileName    = "CON:" 
mov	edx,d[%%%fileInfo.xst]			;;; i663a  
lea	eax,[edx+120]			;;; i464  
mov	ebx,addr @_string.02A4.xst			;;; i663 
mov	edi,eax			;;; i9a 
mov	esi,ebx			;;; i10 
mov	ecx,112			;;; i11 
call	%_assignCompositeStringlet.v			;;; i12 
; 
; [1378] fileInfo[1].fileHandle  = -1 
mov	eax,1			;;; i659  
neg	eax			;;; i916  
mov	ecx,d[%%%fileInfo.xst]			;;; i663a  
lea	ebx,[ecx+120]			;;; i464  
mov	d[ebx+112],eax			;;; i13b 
; 
; [1379] fileInfo[1].entries     = 1  
mov	edx,d[%%%fileInfo.xst]			;;; i663a  
lea	eax,[edx+120]			;;; i464  
mov	ebx,1			;;; i659  
mov	d[eax+116],ebx			;;; i13b 
; 
; [1380] END IF 
else.007E.xst:  
end.if.007E.xst:  
; 
; [1381] END SUB  
end.sub25.1.xst:  
ret				;;; i127 
out.sub25.1.xst:  
; 
; [1382] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XxxWriteFile.xst:  ;;; Function end label for Assembly Programmers. 
end.func25.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	20			;;; i111a  
;-peep  
;  *****  
;  *****  END FUNCTION  XxxWriteFile ()  *****  
;  *****  
; 
; [1383] '  
; 
; [1384] '  
; 
; [1385] ' ############################ 
; 
; [1386] ' #####  XxxReadFile ()  ##### 
; 
; [1387] ' ############################ 
; 
; [1389] '	In:				fileNumber		File Number 
; 
; [1390] '						buffer  
; 
; [1391] '						bytes					to be written 
; 
; [1392] '						bytesRead 
; 
; [1393] '						overlapped		NULL  
; 
; [1394] '  
; 
; [1395] '	Invalid on console windows 
; 
; [1396] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxReadFile ()  ***** 
;  *****  
; 
; [1420] '  
; 
; [1421] '  
; 
; [1422] ' #########################  
; 
; [1423] ' #####  XxxClose ()  #####  
; 
; [1424] ' #########################  
; 
; [1426] '	In:				fileNumber		File number 
; 
; [1427] '						$$ALL					(-1)  Close all files 
; 
; [1428] '  
; 
; [1429] '	Out:			none		(arg unchanged) 
; 
; [1430] '  
; 
; [1431] '	Return:		$$TRUE		error (##ERROR is set)  
; 
; [1432] '						$$FALSE		no error 
; 
; [1433] '  
; 
; [1434] '	User can only close user files 
; 
; [1435] '  
; 
out.sub27.0.xst:  
; 
; [1492] '  
; 
; [1493] SUB CloseError 
jmp	out.sub27.1.xst			;;; i262  
align 16  
%s%CloseError%27: 
; .sub27.0001 = ebp-100	; internal variable 
; 
; [1494] errno	= GetLastError ()  
#ifdef XxxClose.errno 
#undef XxxClose.errno 
#endif  
#define XxxClose.errno ebp-104	; exposes local variable 'errno' 
; 
call	_GetLastError@0			;;; i619b  
mov	d[ebp-104],eax			;;; i670 
; 
; [1495] XstSystemErrorToError (errno, @error)  
#ifdef XxxClose.error 
#undef XxxClose.error 
#endif  
#define XxxClose.error ebp-108	; exposes local variable 'error' 
; 
push	[ebp-108]			;;; i674a  
push	[ebp-104]			;;; i674a  
call	func6.xst			;;; i619b  
mov	ecx,d[esp-4]			;;; i877a  
mov	d[ebp-108],ecx			;;; i670 
; 
; [1496] lastErr = ERROR (error)  
sub	esp,64			;;; i487 
mov	eax,d[ebp-108]			;;; i665 
call	%_error  
add	esp,64			;;; i600 
mov	d[ebp-44],eax			;;; i670  
; 
; [1497] err = $$TRUE 
mov	eax,-1			;;; i659 
mov	d[ebp-40],eax			;;; i670  
; 
; [1498] END SUB  
end.sub27.1.xst:  
ret				;;; i127 
out.sub27.1.xst:  
; 
; [1499] '  
; 
; [1500] eeeBadFileNumber:  
%g%eeeBadFileNumber%27: 
; 
; [1501] error = ($$ErrorObjectFile << 8) OR $$ErrorNatureInvalidArgument 
mov	eax,3			;;; i659  
shl	eax,8			;;; i835  
or	eax,57			;;; i763  
mov	d[ebp-108],eax			;;; i670 
; 
; [1502] lastErr = ERROR (error)  
sub	esp,64			;;; i487 
mov	eax,d[ebp-108]			;;; i665 
call	%_error  
add	esp,64			;;; i600 
mov	d[ebp-44],eax			;;; i670  
; 
; [1503] RETURN ($$TRUE)  
mov	eax,-1			;;; i659 
jmp	end.func27.xst			;;; i258 
; 
; [1504] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XxxClose.xst:  ;;; Function end label for Assembly Programmers. 
end.func27.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	4			;;; i111a 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxClose ()  *****  
;  *****  
; 
; [1505] '  
; 
; [1506] '  
; 
; [1507] ' #######################  
; 
; [1508] ' #####  XxxLof ()  #####  
; 
; [1509] ' #######################  
; 
; [1510] '  
; 
; [1511] '	RETURN	0...	length of file 
; 
; [1512] '					-1		error (##ERROR is set on error)  
; 
; [1513] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxLof ()  *****  
;  *****  
; 
; [1538] '  
; 
; [1539] '  
; 
; [1540] ' ######################## 
; 
; [1541] ' #####  XxxOpen ()  ##### 
; 
; [1542] ' ######################## 
; 
; [1544] '	Open a file, return a fileNumber 
; 
; [1545] '  
; 
; [1546] '	in			: filename$		May include absolute or relative path  
; 
; [1547] '												MUST NOT FREE filename$ (%_open.s must do so) 
; 
; [1548] '	out			: none				(args unaltered) 
; 
; [1549] '	return	: 1...				File Number 
; 
; [1550] '						-1					error (##ERROR is set) 
; 
; [1551] '  
; 
; [1552] '	$$RD			Open existing file for reading only.		Error if file doesn't exist.  
; 
; [1553] '	$$WR			Open existing file for writing only.		Error if file doesn't exist.  
; 
; [1554] '	$$RW			Open existing file for read/write.			Error if file doesn't exist. 
; 
; [1555] '	$$WRNEW		Open new file for writing.  						If file exists, delete it first.  
; 
; [1556] '	$$RWNEW		Open new file for read/write.						If file exists, delete it first. 
; 
; [1557] '	$$NOSHARE Let no other processes access this file. 
; 
; [1558] '	$$RDSHARE Let other processes read this file.  
; 
; [1559] '	$$WRSHARE	Let other processes write this file. 
; 
; [1560] '	$$RWSHARE	Let other processes read/write this file.  
; 
; [1561] '  
; 
; [1562] '	filename$ = "CON:" is a win32 console whose fileNumber is always 1 
; 
; [1563] ' WRITE [1], a$  
; 
; [1564] ' is equivalent to 
; 
; [1565] ' PRINT a$ 
; 
; [1566] ' in a console application.  
; 
; [1567] '  
; 
out.sub29.0.xst:  
; 
; [1657] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XxxOpen.xst:  ;;; Function end label for Assembly Programmers.  
end.func29.xst: 
mov ebx,[ebp-36]  
fs mov [0],ebx       ;;; remove unwind handler  
call free.func29.xst  
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	8			;;; i111a 
free.func29.xst:  
mov	esi,[ebp-44]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxOpen ()  ***** 
;  *****  
; 
; [1658] '  
; 
; [1659] '  
; 
; [1660] ' #######################  
; 
; [1661] ' #####  XxxPof ()  #####  
; 
; [1662] ' #######################  
; 
; [1663] '  
; 
; [1664] '	RETURN	0...	current position 
; 
; [1665] '					-1		error (##ERROR is set on error)  
; 
; [1666] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxPof ()  *****  
;  *****  
; 
; [1687] '  
; 
; [1688] '  
; 
; [1689] ' ###########################  
; 
; [1690] ' #####  XxxInfile$ ()  #####  
; 
; [1691] ' ###########################  
; 
; [1693] '	RETURN	line$		File string  
; 
; [1694] '					""			End of file (##ERROR = $$ErrorEndOfFile)  
; 
; [1695] '					""			error (##ERROR is set on error) 
; 
free.func2B.xst:  
mov	esi,[ebp-52]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxInfile$ ()  *****  
;  *****  
; 
; [1788] '  
; 
; [1789] '  
; 
; [1790] ' ###########################  
; 
; [1791] ' #####  XxxInline$ ()  #####  
; 
; [1792] ' ###########################  
; 
; [1793] '  
; 
; [1794] '	In:			prompt$		MUST NOT FREE prompt$ (%_inline_d.s must do so) 
; 
; [1795] '	RETURN	line$			input string  
; 
; [1796] '					""				error (##ERROR is set on error)  
; 
; [1797] '  
; 
free.func2C.xst:  
mov	esi,[ebp-68]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxInline$ ()  *****  
;  *****  
; 
; [1816] '  
; 
; [1817] '  
; 
; [1818] ' ######################## 
; 
; [1819] ' #####  XxxSeek ()  ##### 
; 
; [1820] ' ######################## 
; 
; [1821] '  
; 
; [1822] '	RETURN	0...	new position 
; 
; [1823] '					-1		error (##ERROR is set on error)  
; 
; [1824] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxSeek ()  ***** 
;  *****  
; 
; [1845] '  
; 
; [1846] '  
; 
; [1847] ' #########################  
; 
; [1848] ' #####  XxxShell ()  #####  
; 
; [1849] ' #########################  
; 
; [1850] '  
; 
; [1851] '	command$	MUST NOT FREE command$ (%_shell.s must do so) 
; 
; [1852] '  
; 
; [1853] '	wait till process completes unless 1st character of command$ = ":" 
; 
; [1854] ' inherit socket and file handles unless 1st character of command$ = "-" 
; 
; [1855] '  
; 
free.func2E.xst:  
mov	esi,[ebp-56]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxShell ()  *****  
;  *****  
; 
; [1932] '  
; 
; [1933] '  
; 
; [1934] ' #################### 
; 
; [1935] ' #####  Xit ()  ##### 
; 
; [1936] ' #################### 
; 
; [1937] '  
; 
out.sub2F.0.xst:  
; 
; [1952] SUB Except 
jmp	out.sub2F.1.xst			;;; i262  
align 16  
%s%Except%2F: 
; .sub2F.0001 = ebp-80	; internal variable  
; 
; [1953] exception.response = $$ExceptionForward  
mov	eax,d[ebp-52]			;;; i665  
mov	ebx,1			;;; i659  
mov	d[eax+16],ebx			;;; i13b  
; 
; [1954] XstGetExceptionFunction (@exFunc)  
push	[ebp-44]			;;; i674a 
call	func39.xst			;;; i619b 
mov	ecx,d[esp-4]			;;; i877a  
mov	d[ebp-44],ecx			;;; i670  
; 
; [1955] IF exFunc THEN 
mov	eax,d[ebp-44]			;;; i665  
test	eax,eax			;;; i220 
jz	>> else.00CF.xst			;;; i221  
; 
; [1956] response = @exFunc() 
#ifdef Xit.response 
#undef Xit.response 
#endif  
#define Xit.response ebp-84	; exposes local variable 'response' 
; 
mov	eax,d[ebp-44]			;;; i665  
xor	edx,edx			;;; i602  
test	eax,eax			;;; i603 
jz	>> A.161			;;; i604  
mov	d[ebp-60],eax			;;; i670  
mov	eax,d[ebp-60]			;;; i665  
call	eax			;;; i620 
A.161:  
mov	d[ebp-84],eax			;;; i670  
; 
; [1957] SELECT CASE response 
mov	eax,d[ebp-84]			;;; i665  
; .select2F.00D0 = ebp-88	; internal variable 
mov	d[ebp-88],eax			;;; i670  
; 
; [1958] CASE $$ExceptionTerminate, $$ExceptionContinue 
mov	eax,0			;;; i659  
mov	ebx,d[ebp-88]			;;; i665  
cmp	eax,ebx			;;; i684a 
je	>> caser.00D0.0000.xst			;;; i70 
mov	eax,-1			;;; i659 
cmp	eax,ebx			;;; i684a 
jne	>> case.00D0.0001.xst			;;; i71 
caser.00D0.0000.xst:  
; 
; [1959] exception.response = response  
mov	eax,d[ebp-52]			;;; i665  
mov	ebx,d[ebp-84]			;;; i665  
mov	d[eax+16],ebx			;;; i13b  
; 
; [1960] CASE ELSE  
jmp	end.select.00D0.xst			;;; i69 
case.00D0.0001.xst: 
; 
; [1961] exception.response = $$ExceptionForward  
mov	eax,d[ebp-52]			;;; i665  
mov	ebx,1			;;; i659  
mov	d[eax+16],ebx			;;; i13b  
; 
; [1962] END SELECT 
end.select.00D0.xst:  
; 
; [1963] END IF 
else.00CF.xst:  
end.if.00CF.xst:  
; 
; [1964] END SUB  
end.sub2F.1.xst:  
ret				;;; i127 
out.sub2F.1.xst:  
; 
; [1966] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.Xit.xst:  ;;; Function end label for Assembly Programmers.  
end.func2F.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	4			;;; i111a 
;-peep  
;  *****  
;  *****  END FUNCTION  Xit ()  ***** 
;  *****  
; 
; [1967] '  
; 
; [1968] '  
; 
; [1969] ' ###################################### 
; 
; [1970] ' #####  XstStringToLongDouble ()  ##### 
; 
; [1971] ' ###################################### 
; 
; [1972] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstStringToLongDouble ()  ***** 
;  *****  
; 
; [2204] '  
; 
; [2205] '  
; 
; [2206] ' #####################################  
; 
; [2207] ' #####  XstGetFPUControlWord ()  #####  
; 
; [2208] ' #####################################  
; 
; [2209] '  
; 
; [2210] ' Return value is current FPU control word.  
; 
; [2211] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstGetFPUControlWord ()  *****  
;  *****  
; 
; [2223] '  
; 
; [2224] '  
; 
; [2225] ' #####################################  
; 
; [2226] ' #####  XstSetFPUControlWord ()  #####  
; 
; [2227] ' #####################################  
; 
; [2228] '  
; 
; [2229] ' Sets the FPU control word. 
; 
; [2230] ' Return value is previous control word. 
; 
; [2231] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSetFPUControlWord ()  *****  
;  *****  
; 
; [2243] '  
; 
; [2244] '  
; 
; [2245] ' ################################## 
; 
; [2246] ' #####  XstSetFPURounding ()  ##### 
; 
; [2247] ' ################################## 
; 
; [2248] '  
; 
; [2249] ' Sets the FPU rounding field of control word. 
; 
; [2250] ' Return value is the previous control word. 
; 
; [2251] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSetFPURounding ()  ***** 
;  *****  
; 
; [2285] '  
; 
; [2286] '  
; 
; [2287] ' ###################################  
; 
; [2288] ' #####  XstSetFPUPrecision ()  #####  
; 
; [2289] ' ###################################  
; 
; [2290] '  
; 
; [2291] ' Set the FPU precision control field  
; 
; [2292] ' in control word. 
; 
; [2293] ' Return value is previous control word. 
; 
; [2294] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSetFPUPrecision ()  *****  
;  *****  
; 
; [2327] '  
; 
; [2328] '  
; 
; [2329] ' ############################ 
; 
; [2330] ' #####  FPClassifyL ()  ##### 
; 
; [2331] ' ############################ 
; 
; [2332] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  FPClassifyL ()  ***** 
;  *****  
; 
; [2347] '  
; 
; [2348] '  
; 
; [2349] ' ########################## 
; 
; [2350] ' #####  IsFiniteL ()  ##### 
; 
; [2351] ' ########################## 
; 
; [2352] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  IsFiniteL ()  ***** 
;  *****  
; 
; [2358] '  
; 
; [2359] '  
; 
; [2360] ' ###################### 
; 
; [2361] ' #####  IsInf ()  ##### 
; 
; [2362] ' ###################### 
; 
; [2363] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  IsInfL ()  *****  
;  *****  
; 
; [2369] '  
; 
; [2370] '  
; 
; [2371] ' #########################  
; 
; [2372] ' #####  IsNormal ()  #####  
; 
; [2373] ' #########################  
; 
; [2374] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  IsNormalL ()  ***** 
;  *****  
; 
; [2380] '  
; 
; [2381] '  
; 
; [2382] ' #######################  
; 
; [2383] ' #####  IsNanL ()  #####  
; 
; [2384] ' #######################  
; 
; [2385] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  IsNanL ()  *****  
;  *****  
; 
; [2400] '  
; 
; [2401] '  
; 
; [2402] ' #########################  
; 
; [2403] ' #####  SignBitL ()  #####  
; 
; [2404] ' #########################  
; 
; [2405] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  SignBitL ()  *****  
;  *****  
; 
; [2420] '  
; 
; [2421] '  
; 
; [2422] ' ######################## 
; 
; [2423] ' #####  IsZeroL ()  ##### 
; 
; [2424] ' ######################## 
; 
; [2425] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  IsZeroL ()  ***** 
;  *****  
; 
; [2440] '  
; 
; [2441] '  
; 
; [2442] ' #############################  
; 
; [2443] ' #####  IsSubNormalL ()  #####  
; 
; [2444] ' #############################  
; 
; [2445] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  IsSubNormalL ()  *****  
;  *****  
; 
; [2460] '  
; 
; [2461] '  
; 
; [2462] ' ###################################### 
; 
; [2463] ' #####  XstEnableFPExceptions ()  ##### 
; 
; [2464] ' ###################################### 
; 
; [2465] '  
; 
; [2466] ' Unmask divide-by-zero, overflow, and underflow FPU exceptions. 
; 
; [2467] ' Returns last control word. 
; 
; [2468] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstEnableFPExceptions ()  ***** 
;  *****  
; 
; [2479] '  
; 
; [2480] '  
; 
; [2481] ' ###################################### 
; 
; [2482] ' #####  GetLocaleDecimalPoint ()  ##### 
; 
; [2483] ' ###################################### 
; 
; [2484] '  
; 
free.func22.xst:  
mov	esi,[ebp-40]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  GetLocaleDecimalPoint ()  ***** 
;  *****  
; 
; [2496] '  
; 
; [2497] ' ################################ 
; 
; [2498] ' #####  Init_POT_Tables ()  ##### 
; 
; [2499] ' ################################ 
; 
; [2500] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  Init_POT_Tables ()  ***** 
;  *****  
; 
; [2784] '  
; 
; [2785] '  
; 
; [2786] ' #######################################  
; 
; [2787] ' #####  XstLongDoubleToString$ ()  #####  
; 
; [2788] ' ###################################### 
; 
; [2789] '  
; 
; [2790] ' PURPOSE : convert a long double to a ascii string. 
; 
; [2791] ' IN			: ld - long double value (must be positive value).  
; 
; [2792] ' 				: maxDigits - count of signficant digits in string, <= 19  
; 
; [2793] '					: expChar - exponent character: 'e', 'E', 'd', or 'D'. 
; 
; [2794] '					: prefixChar - prefix character is '+', '-', space ' ', or 0 for no prefix character.  
; 
; [2795] ' OUT			: returned string  
; 
; [2796] '  
; 
out.sub17.0.xst:  
; 
; [3059] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XstLongDoubleToString$.xst:  ;;; Function end label for Assembly Programmers. 
end.func17.xst: 
mov ebx,[ebp-36]  
fs mov [0],ebx       ;;; remove unwind handler  
call free.func17.xst  
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret	24			;;; i111a  
free.func17.xst:  
mov	esi,[ebp-116]			;;; i665  
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstLongDoubleToString$ ()  *****  
;  *****  
; 
; [3060] '  
; 
; [3061] ' ###################################  
; 
; [3062] ' #####  InitErrorStringArrays  #####  
; 
; [3063] ' ###################################  
; 
; [3064] '  
; 
; [3065] ' Initialize errorObject$[] and errorNature$[] arrays. 
; 
; [3066] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  InitErrorStringArrays ()  ***** 
;  *****  
; 
; [3218] '  
; 
; [3219] '  
; 
; [3220] ' ################################## 
; 
; [3221] ' #####  XstCauseException ()  ##### 
; 
; [3222] ' ################################## 
; 
; [3223] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstCauseException ()  ***** 
;  *****  
; 
; [3230] '  
; 
; [3231] '  
; 
; [3232] ' ################################## 
; 
; [3233] ' #####  XstRaiseException ()  ##### 
; 
; [3234] ' ################################## 
; 
; [3235] '  
; 
; [3236] ' exception is a native exception code or a user code registered through XstRegisterException()  
; 
; [3237] '  
; 
; [3238] ' type is $$ExceptionTypeInformation, $$ExceptionTypeWarning, or $$ExceptionTypeError. If 0, 
; 
; [3239] '            $$ExceptionTypeError is assumed. Valid only for user-registered exceptions. 
; 
; [3240] '  
; 
; [3241] ' arguments[] is an array of arguments to be passed to the .ExceptionInformation[] member  
; 
; [3242] '            of an EXCEPTION_RECORD variable.  Maximum 15 ($$EXCEPTION_MAXIMUM_PARAMETERS) 
; 
; [3243] '            elements; any extras are ignored. 
; 
; [3244] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstRaiseException ()  ***** 
;  *****  
; 
; [3258] '  
; 
; [3259] '  
; 
; [3260] ' #########################################  
; 
; [3261] ' #####  XstExceptionNameToNumber ()  #####  
; 
; [3262] ' #########################################  
; 
; [3263] '  
; 
free.func33.xst:  
mov	esi,[ebp-40]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstExceptionNameToNumber ()  *****  
;  *****  
; 
; [3279] '  
; 
; [3280] '  
; 
; [3281] ' #########################################  
; 
; [3282] ' #####  XstExceptionNumberToName ()  #####  
; 
; [3283] ' #########################################  
; 
; [3284] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstExceptionNumberToName ()  *****  
;  *****  
; 
; [3295] '  
; 
; [3296] '  
; 
; [3297] ' ###############################################  
; 
; [3298] ' #####  XstSystemExceptionNumberToName ()  #####  
; 
; [3299] ' ###############################################  
; 
; [3300] '  
; 
free.func35.xst:  
mov	esi,[ebp-48]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSystemExceptionNumberToName ()  *****  
;  *****  
; 
; [3345] '  
; 
; [3346] '  
; 
; [3347] ' ############################################## 
; 
; [3348] ' #####  XstExceptionToSystemException ()  ##### 
; 
; [3349] ' ############################################## 
; 
; [3350] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstExceptionToSystemException ()  ***** 
;  *****  
; 
; [3386] '  
; 
; [3387] '  
; 
; [3388] ' ############################################## 
; 
; [3389] ' #####  XstSystemExceptionToException ()  ##### 
; 
; [3390] ' ############################################## 
; 
; [3391] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSystemExceptionToException ()  ***** 
;  *****  
; 
; [3431] '  
; 
; [3432] '  
; 
; [3433] ' #####################################  
; 
; [3434] ' #####  XstRegisterException ()  #####  
; 
; [3435] ' #####################################  
; 
; [3436] '  
; 
free.func38.xst:  
mov	esi,[ebp-40]			;;; i665 
call	%____free			;;; i423 
ret 
;-peep  
;  *****  
;  *****  END FUNCTION  XstRegisterException ()  *****  
;  *****  
; 
; [3455] '  
; 
; [3456] '  
; 
; [3457] ' ######################################## 
; 
; [3458] ' #####  XstGetExceptionFunction ()  ##### 
; 
; [3459] ' ######################################## 
; 
; [3460] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstGetExceptionFunction ()  ***** 
;  *****  
; 
; [3466] '  
; 
; [3467] '  
; 
; [3468] ' ######################################## 
; 
; [3469] ' #####  XstSetExceptionFunction ()  ##### 
; 
; [3470] ' ######################################## 
; 
; [3471] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstSetExceptionFunction ()  ***** 
;  *****  
; 
; [3478] '  
; 
; [3479] '  
; 
; [3480] ' #######################  
; 
; [3481] ' #####  XstTry ()  #####  
; 
; [3482] ' #######################  
; 
; [3483] '  
; 
; [3484] ' Installs an exception handler and executes protected code. 
; 
; [3485] '  addrTry is the address of a SUB containing the protected code 
; 
; [3486] '  addrExcept is the address of a SUB containing the exception handler 
; 
; [3487] '  exdata is an EXCEPTION_DATA variable containing information about an exception. 
; 
; [3488] '  
; 
; [3489] 'XstTry() returns normally if: 
; 
; [3490] '  - the protected code ends normally via END SUB or EXIT SUB, possibly after an exception 
; 
; [3491] '     for which SUB Except responded $$ExceptionRetry or $$ExceptionContinue; the return 
; 
; [3492] '     value in this case is 0. 
; 
; [3493] '  - an exception occurs and SUB Except responds $$ExceptionTerminate. Return value is -1. 
; 
; [3494] '  
; 
; [3495] 'XstTry() never returns if:  
; 
; [3496] '  - SUB Except responds $$ExceptionForward; 
; 
; [3497] '  - a previously installed exception handler responds $$ExceptionTerminate, 
; 
; [3498] '     $$ExceptionRetry, or $$ExceptionForward; 
; 
; [3499] '  - a RETURN or EXIT FUNCTION statement is executed within SUB Try or SUB Except. 
; 
; [3500] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstTry ()  *****  
;  *****  
; 
; [3545] '  
; 
; [3546] '  
; 
; [3547] ' ###########################  
; 
; [3548] ' #####  XxxHandler ()  #####  
; 
; [3549] ' ###########################  
; 
; [3550] '  
; 
; [3551] ' Common exception handler installed by XstTry().  
; 
; [3552] ' Called by the OS when an exception occurs. May be called multiple times during the 
; 
; [3553] ' processing of single exception, if multiple XstTry()-installed handlers are active.  
; 
; [3554] '  
; 
; [3555] '  ExRec is filled by the OS, and contains information about the exception 
; 
; [3556] '  ExReg is the EXCEPTION_REGISTRATION created by XstTry() before calling the protected code.  
; 
; [3557] '  Context is filled by the OS and contains information about the processor state when the 
; 
; [3558] '   exception occurred.  
; 
; [3559] '  pDispatcher is used internally by the OS and is not used by XxxHandler()  
; 
; [3560] '  
; 
; [3561] ' XxxHandler() fills the EXCEPTION_DATA variable supplied when XstTry() was called, and then 
; 
; [3562] ' calls the exception-handler SUB, also an argument for XstTry(). If the SUB returns, the  
; 
; [3563] ' EXCEPTION_DATA .response member is used to determine how execution will proceed. The 
; 
; [3564] ' exception-handler SUB will not return here if it raises a new exception or executes  
; 
; [3565] ' a RETURN statement.  
; 
; [3566] '  
; 
out.sub3E.0.xst:  
; 
; [3664] END FUNCTION 
xor	eax,eax			;;; i862  
align 8 
end.XxxHandler.xst:  ;;; Function end label for Assembly Programmers. 
end.func3E.xst: 
lea	esp,[ebp-20]				;;; i110  
pop	ebx				;;; restore ebx  
pop	edi				;;; restore edi  
pop	esi				;;; restore esi  
leave					;;; replaces 'mov esp,ebp' 'pop ebp'  
ret				;;; i111c  
;-peep  
;  *****  
;  *****  END FUNCTION  XxxHandler ()  *****  
;  *****  
; 
; [3665] '  
; 
; [3666] '  
; 
; [3667] ' ############################ 
; 
; [3668] ' #####  XxxUnwinder ()  ##### 
; 
; [3669] ' ############################ 
; 
; [3670] '  
; 
; [3671] 'This handler is installed by each function that allocates local strings or arrays. If 
; 
; [3672] ' the installing function is abandoned due to a stack unwind during exception processing,  
; 
; [3673] ' XxxUnwinder() will call the function's code to free the allocated memory.  
; 
; [3674] '  
; 
; [3675] 'Unwinding in xblite uses an abbreviated EXCEPTION_REGISTRATION; only the first four 
; 
; [3676] '  member are valid. 
; 
; [3677] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxUnwinder ()  ***** 
;  *****  
; 
; [3687] '  
; 
; [3688] '  
; 
; [3689] ' #################################  
; 
; [3690] ' #####  XxxCallExceptSub ()  #####  
; 
; [3691] ' #################################  
; 
; [3692] '  
; 
; [3693] ' call the exception-handler SUB 
; 
; [3694] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XxxCallExceptSub ()  *****  
;  *****  
; 
; [3703] '  
; 
; [3704] '  
; 
; [3705] ' ################################ 
; 
; [3706] ' #####  XstGetException ()  ##### 
; 
; [3707] ' ################################ 
; 
; [3708] '  
; 
; [3709] ' return exception code for the most recent exception  
; 
; [3710] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstGetException ()  ***** 
;  *****  
; 
; [3716] '  
; 
; [3717] '  
; 
; [3718] ' ###########################################  
; 
; [3719] ' #####  XstGetExceptionInformation ()  #####  
; 
; [3720] ' ###########################################  
; 
; [3721] '  
; 
; [3722] ' return exception information for the most recent exception 
; 
; [3723] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  XstGetExceptionInformation ()  *****  
;  *****  
; 
; [3731] '  
; 
; [3732] '  
; 
; [3733] ' ################################ 
; 
; [3734] ' #####  InitExceptionArray  ##### 
; 
; [3735] ' ################################ 
; 
; [3736] '  
; 
; [3737] ' Initialize exception$[] array. 
; 
; [3738] '  
; 
;-peep  
;  *****  
;  *****  END FUNCTION  InitExceptionArray ()  *****  
;  *****  
; 
; [3779] END PROGRAM  
;<peep  
end_program.xst:  
push	ebp			;;; i128 
mov	ebp,esp			;;; i129  
sub	esp,128			;;; i130  
mov	esi,d[%%%errorObject$.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%errorNature$.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%fileInfo.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%fileLock.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%charsetFilenameFirstLast.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%charsetFilename.xst]			;;; i663a 
call	%_FreeArray			;;; i424 
mov	esi,d[%%%POT_IndexP.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%POT_TableN.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%POT_IndexN.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%POT_TableP.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%libraryName$.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esi,d[%%%libraryHandle.xst]			;;; i663a 
call	%_FreeArray			;;; i424 
mov	esi,d[%%%exception$.xst]			;;; i663a  
call	%_FreeArray			;;; i424 
mov	esp,ebp			;;; i132  
pop	ebp			;;; i133  
ret				;;; i134 
; 
InitSharedComposites.xst: 
push	ebp			;;; i135 
mov	ebp,esp			;;; i136  
sub	esp,128			;;; i137  
mov	esi,568			;;; i138  
call	%____calloc			;;; i139a  
mov	eax,esi			;;; i139b 
mov	d[%.composites.xst],eax			;;; i668  
lea	eax,[esi]			;;; i140  
lea	ebx,[esi+80]			;;; i140a  
lea	ecx,[esi+284]			;;; i140b 
lea	edx,[esi+364]			;;; i140c 
mov	d[%infoRecord.xst],eax			;;; i668 
mov	d[%infoContext.xst],ebx			;;; i668  
mov	d[%infoRecord.xst],ecx			;;; i668 
mov	d[%infoContext.xst],edx			;;; i668  
mov	esp,ebp			;;; i141  
pop	ebp			;;; i142  
ret				;;; i143 
; 
.code 
; ########################  
; #####  DllMain ()  #####  
; ########################  
; New startup sequence for XBLite by Ken Minogue - 12/15/03 
; - The system loads xbl.dll, calls DllMain to initialize memory and xst. 
; - Xio() is called from Xst(), instead of Xit(), to ensure the console is  
;   initialized regardless of how xbl.dll is loaded.  
; - The system calls WinMain, which pushes %_StartApplication and calls Xit().  
; - Xit() sets up the exception handler and calls the user application. 
; ********************************  
; DllMain is written slightly differently from my previous version, with three  
; goals in mind:  
; - to ensure that xbl.dll is always properly initialized when a process starts,  
;   even if the process is an exe written in another language.  At present, if I  
;   write an XBLite dll and call it from a C program, the program will crash as soon  
;   as memory allocation is attempted - because _XxxMain is never called and xbl.dll  
;   is never initialized. 
; - to initialize the FPU when a thread is started. 
; - to maintain compatibility with current XBLite executables.  
align 8 
%_XxxXstInitialize: 
push 0  
push 1								; simulate DLL_PROCESS_ATTACH 
push 0  
call noDllMain  
ret 
; 
noDllMain:  
push ebp  
mov ebp,esp 
mov eax,[ebp+12] 				; fdwReason  
or eax,eax  
jz > process_detach 
dec eax 
jz > process_attach 
dec eax 
jz > thread_attach  
dec eax 
jz > thread_detach  
xor eax,eax     				; error - illegal argument  
jmp exit_DllMain  
process_attach: 
cmp d[%initialized],0		; is it already done?  
jne > D.1 
call initialize  				; initialize memory allocation 
call _Xst@0     				; initialize xst arrays, and also Xio() 
thread_attach:						; initialize FPU, set precision to 64-bit 
finit										; unmask divide-by-zero, overflow, and underflow FPU exceptions  
sub esp,4 
fstcw W[esp]  
and D[esp],0xFFFFFFE3 
fldcw W[esp]  
add esp,4 
D.1:  
mov eax,1     					; success  
process_detach: 
thread_detach:  
exit_DllMain: 
mov esp,ebp 
pop ebp 
ret 12  
; 
;;;  *****  DEFINE '.bss' SECTION LIMITS  ***** 
; 
align 8 
data section 'xst$aaaaa'  
%_begin_external_data_xst dd ?  
; 
align 8 
data section 'xst$zzzzz'  
%_end_external_data_xst dd ?  
; 
; 
;;;  *****  DEFINE LITERAL STRINGS  ***** 
.const  
align 8 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
; 
